package ij.plugin;

/*
 * @(#)MemoryMonitor.java	1.26 99/04/23
 *
 * Copyright (c) 1998, 1999 by Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

/**
 * 05/07/31, added sequential system.gc() call
 */


import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import java.awt.image.ColorModel;
import java.awt.image.IndexColorModel;
import java.lang.reflect.Method;
import javax.swing.*;
import ij.process.ImageProcessor;

import ij.gui.GUI;
import ij.IJ;
import ij.ImageJ;

import java.net.URL;
import ij.Prefs;
import ij.process.ByteProcessor;
import ij.process.ImageStatistics;
import ij.measure.Measurements;
import ij.ImagePlus;
import ij2x.plugin.event.WindowsListener;
import ij2x.plugin.event.MouseInputHandler;


/**
 * Tracks Memory allocated & used, displayed in graph form.
 */
public class Memory_Monitor extends JFrame implements PlugIn, WindowListener, MouseListener, MouseMotionListener{

    private Point press, px, py;
    private boolean dragging;

    private Surface surf;
    private ImageJ ij;
    private Image image, img, buttonImg, macImage, nonmacImage;
    private ImageIcon imgic, imgtpic, bic, macIcon;
    private Shape rectangle, rect, movRect;
    private boolean hit=false;
    private Point start_drag;
    private Point start_loc;
    private MouseInputHandler handler;

    public static final int DOUBLE_CLICK_THRESHOLD = 5;

    public Memory_Monitor() {
        super("");
    }

    /**
        * Try's to make the given {@link Window} non-opqaue (transparent) across
        * platforms and JREs. This method is not guaranteed to succeed, and will fail
        * silently if the given {@code Window} cannot be made non-opaque.
        *
        * This method is useful, for example, when creating a HUD style window that
        * is semi-transparent, and thus doesn't want the window background to be
        * drawn.
        * @param window the {@code Window} to make non-opaque.
        */
       public static void makeWindowNonOpaque(Window window) {
           // on the mac, simply setting the window's background color to be fully
           // transparent makes the window non-opaque.
           window.setBackground(new Color(0, 0, 0, 0));
           // on non-mac platforms, try to use the facilities of Java 6 update 10.
           if (!IJ.isMacOSX()) {
               quietlyTryToMakeWindowNonOqaque(window);
           }
       }

       /**
        * Trys to invoke {@code com.sun.awt.AWTUtilities.setWindowOpaque(window, false)}
        * on the given {@link Window}. This will only work when running with JRE 6 update 10
        * or higher. This method will silently fail if the method cannot be invoked.
        * @param window the {@code Window} to try and make non-opaque.
        */
       private static void quietlyTryToMakeWindowNonOqaque(Window window) {
           try {
               Class clazz = Class.forName("com.sun.awt.AWTUtilities");
               Method method =
                       clazz.getMethod("setWindowOpaque", java.awt.Window.class, Boolean.TYPE);
               method.invoke(clazz, window, false);
           } catch (Exception e) {
               // silently ignore this exception.
           }
       }
        private Icon createIcon(String key){
            Icon icon = null;
            String dir = Prefs.getString("icondir");
            String fileName=key+".png";
            String path = dir+fileName;
            URL url = getClass().getResource(path);
            if(url != null)
            icon = new ImageIcon(url);
        return icon;
        }
    public void run(String arg) {

            ij = IJ.getInstance();
            surf = new Surface();
            imgic = (ImageIcon)createIcon("splash/splash_blue_091");
            imgtpic = (ImageIcon)createIcon("splash/splash_red_tp_092");
            image = imgic.getImage();
            img = imgtpic.getImage();
            macIcon   = (ImageIcon)createIcon("opqaue/apple_04");
            bic   = (ImageIcon)createIcon("opqaue/nonmac");
            nonmacImage=bic.getImage();
            buttonImg=bic.getImage();
            macImage=macIcon.getImage();
            buttonImg = IJ.isMacintosh() ? macImage : nonmacImage;
            rootPane = getRootPane();
           try {
                 surf.start();
               } catch (Exception ex) {}

        surf.addMouseListener(this);
        surf.addMouseMotionListener(this);
        rectangle=new Rectangle(image.getWidth(null)-buttonImg.getWidth(null)+34-5,buttonImg.getHeight(null)/2-5, buttonImg.getWidth(null)-34, buttonImg.getHeight(null));
        rect=new Rectangle(image.getWidth(null)-buttonImg.getWidth(null)-5,buttonImg.getHeight(null)/2-5, buttonImg.getWidth(null), buttonImg.getHeight(null));
        movRect=new Rectangle(img.getWidth(null)/2 ,0 ,img.getWidth(null)/2, img.getHeight(null));
        handler = new  MouseInputHandler();
        addMouseListener(handler);
        addMouseMotionListener(handler);
        addComponentListener(handler);

                        Image img = ij.getIconImage();
                        if (img!=null)
                                try {setIconImage(img);} catch (Exception e) {}

        setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        setUndecorated(true);
        rootPane.setWindowDecorationStyle(JRootPane.NONE);
        makeWindowNonOpaque(this);
        this.getContentPane().add(surf);
        pack();
        GUI.center(this);
        setResizable(false); // make resizable on Linux
        setVisible(true);
    }

    Point getScreenLocation(MouseEvent e) {
        Point cursor = e.getPoint();
        Point target_location = this.getLocationOnScreen();
        return new Point(
            (int)(target_location.getX()+cursor.getX()),
            (int)(target_location.getY()+cursor.getY()));
    }
    public void mousePressed(MouseEvent e) {
        this.start_drag = this.getScreenLocation(e);
        this.start_loc = this.getLocation();
        dragging=true;
        mouseClicked(e);
   }
    public void mouseReleased(MouseEvent e) {
    px=e.getPoint();py=e.getPoint();
    setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    dragging=false;
    }
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {
             if(dragging && e.getClickCount() == 1 && rectangle.getBounds().contains(e.getPoint()))
                 {close();
                     dragging=false;
                 }
    }
    public void mouseEntered(MouseEvent e) {}

    public void mouseMoved(MouseEvent event) {
           if(rectangle.getBounds().contains(event.getPoint())){
             setCursor(new Cursor(Cursor.HAND_CURSOR));
             hit=true;
         }else{
             setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
             hit=false;
        }
  }
        public void mouseDragged(MouseEvent event) {
            JComponent c = (JComponent)event.getSource();
             if(!hit && !rect.getBounds().contains(event.getPoint()) && movRect.getBounds().contains(event.getPoint())){
             setCursor(new Cursor(Cursor.MOVE_CURSOR));

             Point current = this.getScreenLocation(event);
             Point offset = new Point(
                 (int)current.getX()-(int)start_drag.getX(),
                 (int)current.getY()-(int)start_drag.getY());
             JFrame frame = Memory_Monitor.this;
             Point new_location = new Point(
                 (int)(this.start_loc.getX()+offset.getX()),
                 (int)(this.start_loc.getY()+offset.getY()));
             frame.setLocation(new_location);
             }
             else {
                 setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
             }
}
        public void windowClosing(WindowEvent e) {
            if (e.getSource()==this)
                    close();
        }

        /** Closes this window. */
        public void close() {
                    setVisible(false);
                    dispose();
        }

        public void windowActivated(WindowEvent e) {
                    if (IJ.isMacintosh() && IJ.getInstance()!=null) {
                    }
            }


        public void windowOpened(WindowEvent e) {}
        public void windowClosed(WindowEvent e) {}
        public void windowIconified(WindowEvent e) {}
        public void windowDeiconified(WindowEvent e) {}
        public void windowDeactivated(WindowEvent e) {}


    public class Surface extends JComponent implements Runnable {

        public Thread thread;
        public long sleepAmount = 1000;
        private int w, h;
        private BufferedImage bimg;
        private Graphics2D big;
        private Font font = new Font("Times New Roman", Font.PLAIN, 11);
        private Runtime r = Runtime.getRuntime();
        private int columnInc;
        private int pts[];
        private int ptNum;
        private int ascent, descent;
        private float freeMemory, totalMemory;
        private Rectangle graphOutlineRect = new Rectangle();
        private Rectangle2D mfRect = new Rectangle2D.Float();
        private Rectangle2D muRect = new Rectangle2D.Float();
        private Line2D graphLine = new Line2D.Float();
        private Color graphColor = new Color(46, 139, 87);
        private Color mfColor = new Color(0, 100, 0);
        private String usedStr;

                private int gc_counter = 0;

        public Surface() {
            setBackground(Color.black);
           this.addMouseListener(new MouseAdapter() {
                public void mouseClicked(MouseEvent e) {
                    if (thread == null) start(); else stop();
                }
            });
        }


        public Dimension getMinimumSize() {
            return getPreferredSize();
        }

        public Dimension getMaximumSize() {
            return getPreferredSize();
        }

        public Dimension getPreferredSize() {
            return new Dimension(320, 250);
        }

        public void paintComponent(Graphics g) {
            super.paintComponent(g);
             paint(g);
        }
        public void paint(Graphics g) {

            if (big == null) {
                return;
            }

            big.setBackground(getBackground());
            big.clearRect(0,0,w,h);

            float freeMemory = (float) r.freeMemory();
            float totalMemory = (float) r.totalMemory();
            float used = IJ.currentMemory();

            // .. Draw allocated and used strings ..
            big.setColor(Color.green);
            big.drawString(String.valueOf((int) totalMemory/1024) + "K allocated",  4.0f, (float) ascent+0.5f);
            usedStr = String.valueOf(((int) (used))/1024) + "K used";
            big.drawString(usedStr, 4, h-descent);

            // Calculate remaining size
            float ssH = ascent + descent;
            float remainingHeight = (float) (h - (ssH*2) - 0.5f);
            float blockHeight = remainingHeight/10;
            float blockWidth = 20.0f;
            float remainingWidth = (float) (w - blockWidth - 10);

            // .. Memory Free ..
            big.setColor(mfColor);
            int MemUsage = (int) ((freeMemory / totalMemory) * 10);
            int i = 0;
            for ( ; i < MemUsage ; i++) {
                mfRect.setRect(5,(float) ssH+i*blockHeight,
                                blockWidth,(float) blockHeight-1);
                big.fill(mfRect);
            }

            // .. Memory Used ..
            big.setColor(Color.green);
            for ( ; i < 10; i++)  {
                muRect.setRect(5,(float) ssH+i*blockHeight,
                                blockWidth,(float) blockHeight-1);
                big.fill(muRect);
            }

            // .. Draw History Graph ..
            big.setColor(graphColor);
            int graphX = 30;
            int graphY = (int) ssH;
            int graphW = w - graphX - 5;
            int graphH = (int) remainingHeight;
            graphOutlineRect.setRect(graphX, graphY, graphW, graphH);
            big.draw(graphOutlineRect);

            int graphRow = graphH/10;

            // .. Draw row ..
            for (int j = graphY; j <= graphH+graphY; j += graphRow) {
                graphLine.setLine(graphX,j,graphX+graphW,j);
                big.draw(graphLine);
            }

            // .. Draw animated column movement ..
            int graphColumn = graphW/15;

            if (columnInc == 0) {
                columnInc = graphColumn;
            }

            for (int j = graphX+columnInc; j < graphW+graphX; j+=graphColumn) {
                graphLine.setLine(j,graphY,j,graphY+graphH);
                big.draw(graphLine);
            }

            --columnInc;

            if (pts == null) {
                pts = new int[graphW];
                ptNum = 0;
            } else if (pts.length != graphW) {
                int tmp[] = null;
                if (ptNum < graphW) {
                    tmp = new int[ptNum];
                    System.arraycopy(pts, 0, tmp, 0, tmp.length);
                } else {
                    tmp = new int[graphW];
                    System.arraycopy(pts, pts.length-tmp.length, tmp, 0, tmp.length);
                    ptNum = tmp.length - 2;
                }
                pts = new int[graphW];
                System.arraycopy(tmp, 0, pts, 0, tmp.length);
            } else {
                big.setColor(Color.yellow);
                pts[ptNum] = (int)(graphY+graphH*(freeMemory/totalMemory));
                for (int j=graphX+graphW-ptNum, k=0;k < ptNum; k++, j++) {
                    if (k != 0) {
                        if (pts[k] != pts[k-1]) {
                            big.drawLine(j-1, pts[k-1], j, pts[k]);
                        } else {
                            big.fillRect(j, pts[k], 1, 1);
                        }
                    }
                }
                if (ptNum+2 == pts.length) {
                    // throw out oldest point
                    for (int j = 1;j < ptNum; j++) {
                        pts[j-1] = pts[j];
                    }
                    --ptNum;
                } else {
                    ptNum++;
                }
            }

                        if (gc_counter > 4)
                        {
                                    if (thread != null && freeMemory < 2048000L)
                                {
                                        big.setColor(Color.red);
                                        big.fillRect(84, h - descent - 6, 4, 4);

                                        System.gc();
                                }

                                gc_counter = 0;
                        }
                        else
                                gc_counter++;

                    /*  BufferedImage bimg contain memory-monitor images */
                            g.drawImage(bimg, 35, 48, this);
                            g.drawImage(bimg, 190, 48, this);
                            g.drawImage(bimg, 35, 158, this);
                            g.drawImage(bimg, 190, 158, this);

                            g.drawImage(image, 0, 0, this);
                            g.drawImage(img, 0, 0, this);
                            g.drawImage(buttonImg,image.getWidth(null)-buttonImg.getWidth(null)-5, buttonImg.getHeight(null)/2-5,this);
       }


        public void start() {
            thread = new Thread(this);
            thread.setPriority(Thread.MIN_PRIORITY);
            thread.setName("MemoryMonitor");
            thread.start();
        }


        public synchronized void stop() {
            thread = null;
            notify();
        }


        public void run() {
            Thread me = Thread.currentThread();

            while (thread == me && !isShowing() || getSize().width == 0) {
                try {
                    thread.sleep(500);
                } catch (InterruptedException e) { return; }
            }

            while (thread == me && isShowing()) {
                Dimension d = getSize();
                if (d.width != w || d.height != h) {
                    w = d.width-2-221;  // 320-223=97
                    h = d.height-21-162;// 250-183=67
                    bimg = (BufferedImage) createImage(w, h);
                    big = bimg.createGraphics();
                    big.setFont(font);
                    FontMetrics fm = big.getFontMetrics(font);
                    ascent = (int) fm.getAscent();
                    descent = (int) fm.getDescent();
                }

                repaint();

                try {
                    thread.sleep(sleepAmount);
                } catch (InterruptedException e) { break; }
            }
            thread = null;
        }
    }
}
class GradientPlot extends JComponent implements Measurements {

        static final int WIDTH = 256, HEIGHT=68;
        double minThreshold = 85;
        double maxThreshold = 170;
        int[] histogram;
        Color[] hColors;
        int hmax;
        Image os;
        BufferedImage bos;
        Graphics osg;
        int mode;

        public GradientPlot() {
                setSize(WIDTH+1, HEIGHT+1);
        }

    /** Overrides Component getPreferredSize(). Added to work
        around a bug in Java 1.4.1 on Mac OS X.*/
    public Dimension getPreferredSize() {
        return new Dimension(WIDTH+1, HEIGHT+1);
    }

        ImageStatistics setHistogram(ImagePlus imp) {
                ImageProcessor ip = imp.getProcessor();
                if (!(ip instanceof ByteProcessor)) {
                        double min = ip.getMin();
                        double max = ip.getMax();
                        ip.setMinAndMax(min, max);
                        ip = new ByteProcessor(ip.createImage());
                }
                ip.setRoi(imp.getRoi());
                ImageStatistics stats = ImageStatistics.getStatistics(ip, AREA+MIN_MAX+MODE, null);
                int maxCount2 = 0;
                histogram = stats.histogram;
                for (int i = 0; i < stats.nBins; i++)
                        if ((histogram[i] > maxCount2) && (i != stats.mode))
                                maxCount2 = histogram[i];
                hmax = stats.maxCount;
                if ((hmax>(maxCount2 * 2)) && (maxCount2 != 0)) {
                        hmax = (int)(maxCount2 * 1.5);
                        histogram[stats.mode] = hmax;
                }
                os = null;

                ColorModel cm = ip.getColorModel();
                if (!(cm instanceof IndexColorModel))
                        return null;
                IndexColorModel icm = (IndexColorModel)cm;
                int mapSize = icm.getMapSize();
                if (mapSize!=256)
                        return null;
                byte[] r = new byte[256];
                byte[] g = new byte[256];
                byte[] b = new byte[256];
                icm.getReds(r);
                icm.getGreens(g);
                icm.getBlues(b);
                hColors = new Color[256];
                for (int i=0; i<256; i++)
                        hColors[i] = new Color(r[i]&255, g[i]&255, b[i]&255);
                return stats;
        }

        public void update(Graphics g) {
            paintComponent(g);
        }

        public void paintComponent(Graphics g) {
            super.paintComponent(g);
                if (g==null) return;
                if (histogram!=null) {
                        if (os==null && hmax>0) {
                                os = createImage(WIDTH,HEIGHT);
                                osg = os.getGraphics();
                                UIDefaults uid = UIManager.getLookAndFeel().getDefaults();
                                Color bg = uid.getColor("Panel.background");
                                osg.setColor(Color.white);
                                osg.fillRect(0, 0, WIDTH, HEIGHT-20);
                                osg.setColor(bg);
                                osg.fillRect(0, HEIGHT-20, WIDTH, 20);
                                osg.setColor(Color.gray);
                                for (int i = 0; i < WIDTH; i++) {
                                        if (hColors!=null) osg.setColor(hColors[i]);
                                        osg.drawLine(i, HEIGHT-20, i, HEIGHT-20 - ((int)((HEIGHT-20) * histogram[i])/hmax));
                                        osg.drawLine(i, HEIGHT-12, i, HEIGHT-5);
                                }
                                osg.dispose();
                        }
                        g.drawImage(os, 0, 0, this);
                } else {
                        g.setColor(Color.white);
                        g.fillRect(0, 0, WIDTH, HEIGHT);
                }
                g.setColor(Color.black);
                g.drawRect(0, 0, WIDTH, HEIGHT);
    }


} // ThresholdPlot class
