/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2011</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

package ij2x.plugin;

import java.awt.Color;
import java.awt.Container;
import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Rectangle;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import java.net.URL;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.ButtonGroup;
import javax.swing.JComponent;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.border.Border;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.SpinnerNumberModel;

import javax.swing.border.BevelBorder;
import javax.swing.border.Border;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import ij.ImagePlus;
import ij.process.ImageProcessor;

import ij.WindowManager;

import ij.gui.GenericDialog;
import ij.IJ;
import ij.Prefs;
import ij.gui.Roi;
import ij.plugin.PlugIn;
import ij2x.util.*;
import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;

public class AlignRGB implements PlugIn, DocumentListener, ItemListener, ChangeListener, ActionListener{

    protected Icon icon;
    protected Vector<JComponent> checkBox, lutCheckBox;
    protected static int tempColor=0, index, lutColorIndex;
    protected JCheckBox redCheckbox, greenCheckbox, blueCheckbox;
    private ButtonGroup group;
    public boolean isShowing=false, isEnlarge=false;
    public boolean isLUT = false;
    protected static boolean isRedChecked=true, isGreenChecked=false, isBlueChecked=false;
    public static final int DOUBLE_CLICK_THRESHOLD = 650;
    protected BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    protected Border grayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.gray, Color.lightGray);
    protected Border lightGrayBorder = BorderFactory.createBevelBorder(bb.LOWERED, Color.lightGray, Color.lightGray);
    protected JPanel buttonPanel;
    protected JButton upButton, leftButton, rightButton, downButton, revertButton;
    protected JSpinner transParam;
    protected JTextField[] alignvText = new JTextField[4];
    protected JTextField[] alignhText = new JTextField[4];
    protected String[][] names = {{"Red","Green","Blue"}, {"","", ""}};
    protected boolean[] checked={isRedChecked, isGreenChecked, isBlueChecked};

    protected static int param = 0;
    protected ImagePlus imp;
    protected static ImagePlus clipBoard;
    protected ImageProcessor ip;
    protected int width, height, pixel, x, y, stx, sty;
    protected int flag[] ={1, 1, 1}; //flag [RGB]
    protected int rgbXY[][] = new int [3][2]; //[RGB][xy]
    protected int rgbXYM[][] = new int [3][2]; //[RGB][xy]
    protected double rgbX[] = new double [3]; //[RGB]
    protected double rgbY[] = new double [3]; //[RGB]

    protected int r[][];
    protected int g[][];
    protected int b[][];
    protected GridBagLayout layout;
    protected int[] hRGB = new int[3];
    protected int[] vRGB = new int[3];
    protected Roi roi;
    private static ResourceBundle resources;
    private int indexes = 0;

    static {
        try {
            resources = ResourceBundle.getBundle("ij2x.plugin.resources.AlignRGB",
                                                 Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("resources/AlignRGB.properties not found");
            System.exit(1);
        }
    }


    public AlignRGB() {
    }
    public void run(String arg){
        try {
            imp = WindowManager.getCurrentImage();
            if(imp == null)IJ.error(" there are no images open ");
            else if (imp!=null) {
                  roi = imp.getRoi();
                  Rectangle r = roi!=null?roi.getBounds():null;
                  isEnlarge = r==null || (r.x==0&&r.y==0&&r.width==imp.getWidth()&&r.height==imp.getHeight());
              }
          if(!isEnlarge)imp.killRoi();
          imp.copy(false);
          clipBoard=imp.getClipboard();
          if(!isEnlarge)imp.setRoi(roi);
            index = 0;

            if (imp.getType() != ImagePlus.COLOR_RGB) {
                    IJ.showMessage("RGB image required.");
                    return;
            }

            get3Planes(imp);

            if (!showDialog()){
                rebuildImage(imp, clipBoard);
                return;
            }
        } catch (Exception ex) {
            IJ.error("Error", "AlignROIRGB class not found !");
        }
    }
    void rebuildImage(ImagePlus imp, ImagePlus clipBoard){
      try {
          imp.setImage(clipBoard.getImage());
          if(!isEnlarge)imp.setRoi(roi);
          imp.updateAndDraw();
      } catch (Exception ex) {
      }
    }

    void get3Planes(ImagePlus imp){
        ip = imp.getProcessor();
        stx   = isEnlarge ? 0 : roi.getBounds().x;
   width = isEnlarge ? ip.getWidth() : roi.getBounds().width+stx;
   rgbX[0]=rgbX[1]=rgbX[2] = isEnlarge ? (double)width : (double)width-stx;

        sty   = isEnlarge ? 0 : roi.getBounds().y;
   height = isEnlarge ? ip.getHeight() : roi.getBounds().height+sty;
   rgbX[0]=rgbX[1]=rgbX[2] = isEnlarge ? (double)height : (double)height-sty;
   //IJ.log(width+", "+height);
   r = isEnlarge ? new int [width][height] : new int [width-stx][height-sty] ;
   g = isEnlarge ? new int [width][height] : new int [width-stx][height-sty] ;
   b = isEnlarge ? new int [width][height] : new int [width-stx][height-sty] ;

        // get the 3 planes
        for(y=sty;y<height;y++) {
                for(x=stx;x<width;x++){
                        pixel=ip.getPixel(x,y);
                        r[x][y]=((pixel & 0xff0000) >> 16);
                        g[x][y]=((pixel & 0x00ff00) >> 8);
                        b[x][y]=(pixel & 0x0000ff);
                }
        }
        imp.changes = true;
    }

    boolean showDialog() {
       boolean colorOrLut=true;
       group = new ButtonGroup();
       switch(index){
       case 0:
           colorOrLut = colorGUI();
           break;
       case 1:
           //colorOrLut = lutGUI(gd);
           break;
       }
       return colorOrLut;
    }

    boolean colorGUI(){
        GenericDialog gd = new GenericDialog("Align RGB Panel");
        JLabel rgbLabel = new JLabel(" Align RGB ");
        rgbLabel.setBorder(grayBorder);
        JPanel rgbPanel = new JPanel();
        rgbPanel.add(rgbLabel);
        gd.addPanel(rgbPanel, GridBagConstraints.WEST, new Insets(0, 5, 0, 10));
        JPanel checkBoxPanel=new JPanel();
        JPanel controlPanel=new JPanel();
        JPanel infovPanel = new JPanel();
        JPanel infohPanel = new JPanel();
        layout = new GridBagLayout();
        infovPanel.setLayout(layout);
        infohPanel.setLayout(layout);
        for(int i=0; i<4; i++){
            alignhText[i] = new JTextField(3);
            if(i == 0){alignhText[i] = new JTextField(5);alignhText[i].setText("Halign :");alignhText[i].setEditable(false);}
            else {
                alignhText[i].getDocument().addDocumentListener(this);
                alignhText[i].setText("0");
            }
            Insets insets = new Insets(3, 3, 3, 3);
            addComponent(infohPanel, 0, i, 1, 1, 0, 0, GridBagConstraints.NORTH, GridBagConstraints.NONE, insets, 0, 0, new GridBagConstraints(), layout, alignhText[i]);
        }
        for(int i=0; i<4; i++){
            alignvText[i] = new JTextField(3);
            if(i == 0){alignvText[i] = new JTextField(5);alignvText[i].setText("Valign :");alignvText[i].setEditable(false);}
            else {
                alignvText[i].getDocument().addDocumentListener(this);
                alignvText[i].setText("0");
            }
            Insets insets = new Insets(3, 3, 3, 3);
            addComponent(infovPanel, 0, i, 1, 1, 0, 0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, insets, 0, 0, new GridBagConstraints(), layout, alignvText[i]);
        }
        buttonPanel=new JPanel();
        int minValue=0, maxValue=100, defaultValue=param;
        SpinnerNumberModel snm = new SpinnerNumberModel(defaultValue, minValue, maxValue, 1.0);
        transParam = new JSpinner(snm);
        transParam.addChangeListener(this);

                 AWTImages.setImageDir("dirPlayer");

                 String[] iconAllName = ResourceString.tokenize(ResourceString.getResourceString(resources, "alignrgb"));

                 Image[][] icons = new Image[iconAllName.length][3];
                try {
                    for (int i = 0; i < iconAllName.length; i++) {
                        for (int j = 0; j < 3; j++) {
                            icons[i][j] = ((ImageIcon) AWTImages.createIcon(
                                    this,
                                    ResourceString.tokenize(ResourceString.
                                    getResourceString(resources, iconAllName[i]))[
                                    j])).getImage();
                        }
                    }
                } catch (Exception ex) {
                    ex.printStackTrace();
                }


        revertButton=BorderlessButton.createButton(this, revertButton, "Revert", icons[indexes++]);

        upButton=BorderlessButton.createButton(this, upButton, "Trans Up", icons[indexes++]);

        leftButton=BorderlessButton.createButton(this, leftButton, "Trans Left", icons[indexes++]);

        rightButton=BorderlessButton.createButton(this, rightButton, "Trans Right", icons[indexes++]);

        downButton=BorderlessButton.createButton(this, downButton, "Trans Down", icons[indexes]);

        checkBoxPanel.add(gd.addCheckboxGroupPanel(1, 3, names[index], checked));
        controlPanel.add(checkBoxPanel);
        buttonPanel.add(revertButton);
        JPanel panel = new JPanel();
        panel.setLayout(layout);
        Insets insets = new Insets(3, 3, 3, 3);
        GridBagConstraints constraints =  new GridBagConstraints();
        addComponent(panel, 1, 1, 1, 1, 0, 0, GridBagConstraints.NORTH, GridBagConstraints.NONE, insets, 0, 0, constraints, layout, upButton);
        addComponent(panel, 2, 0, 1, 1, 0, 0, GridBagConstraints.WEST, GridBagConstraints.NONE, insets, 0, 0, constraints, layout, leftButton);
        addComponent(panel, 2, 1, 1, 1, 0, 0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, insets, 0, 0, constraints, layout, transParam);
        addComponent(panel, 2, 2, 1, 1, 0, 0, GridBagConstraints.EAST, GridBagConstraints.NONE, insets, 0, 0, constraints, layout, rightButton);
        addComponent(panel, 3, 1, 1, 1, 0, 0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, insets, 0, 0, constraints, layout, downButton);
        panel.setBorder(lightGrayBorder);
        checkBoxPanel.setBorder(lightGrayBorder);

        gd.addPanel(controlPanel, GridBagConstraints.CENTER, new Insets(0, 0, 0, 0));
        gd.addPanel(panel, GridBagConstraints.CENTER, new Insets(0, 0, 0, 0));
        gd.addPanel(infohPanel, GridBagConstraints.CENTER, new Insets(0, 0, 0, 0));
        gd.addPanel(infovPanel, GridBagConstraints.CENTER, new Insets(0, 0, 0, 0));
        gd.addPanel(buttonPanel, GridBagConstraints.CENTER, new Insets(5, 0, 5, 0));

        checkBox=gd.getCheckboxes();
        redCheckbox=(JCheckBox)checkBox.elementAt(0);
        greenCheckbox=(JCheckBox)checkBox.elementAt(1);
        blueCheckbox=(JCheckBox)checkBox.elementAt(2);
        redCheckbox.addItemListener(this);
        blueCheckbox.addItemListener(this);
        greenCheckbox.addItemListener(this);
        redCheckbox.setToolTipText("Red Color");
        blueCheckbox.setToolTipText("Green Color");
        greenCheckbox.setToolTipText("Blue Color");
        group.add(redCheckbox);
        group.add(greenCheckbox);
        group.add(blueCheckbox);
        redCheckbox.setSelected(isRedChecked=gd.getNextBoolean());
        greenCheckbox.setSelected(isGreenChecked=gd.getNextBoolean());
        blueCheckbox.setSelected(isBlueChecked=gd.getNextBoolean());
        buttonPanel.setBorder(lightGrayBorder);
        infohPanel.setBorder(lightGrayBorder);
        infovPanel.setBorder(lightGrayBorder);
        alignvText[0].setEditable(false);
        alignvText[1].setEnabled(isRedChecked);
        alignvText[2].setEnabled(isGreenChecked);
        alignvText[3].setEnabled(isBlueChecked);
        alignhText[0].setEditable(false);
        alignhText[1].setEnabled(isRedChecked);
        alignhText[2].setEnabled(isGreenChecked);
        alignhText[3].setEnabled(isBlueChecked);
        gd.showDialog();
        if (gd.wasCanceled()){
            isShowing=false;
        }
        else {
            isShowing=true;
        }
        isRedChecked=redCheckbox.isSelected() ;
        if(isRedChecked)tempColor=0;
        isGreenChecked=greenCheckbox.isSelected();
        if(isGreenChecked)tempColor=1;
        isBlueChecked=blueCheckbox.isSelected();
        if(isBlueChecked)tempColor=2;
        return isShowing;
    }

    void align(){
            int sx=0, ex=0, sy=0, ey=0, plane = tempColor;

            if(plane==0){
                    for(y=0;y<height;y++) {
                            for(x=0;x<width;x++)
                                    ip.putPixel(x,y, ((0 & 0xff) <<16)+ ((g[x][y] & 0xff) << 8) + (b[x][y] & 0xff));
                    }
                    if(rgbXY[0][0]>=0 && rgbXY[0][1]>=0) {sx=rgbXY[0][0]; ex= width; sy=rgbXY[0][1]; ey=height; }
                    else if (rgbXY[0][0]<=0 && rgbXY[0][1]<=0){ sx=0; ex= width+rgbXY[0][0]; sy=0; ey=height+rgbXY[0][1]; }
                    else if (rgbXY[0][0]<=0 && rgbXY[0][1]>=0){ sx=0; ex= width+rgbXY[0][0]; sy=rgbXY[0][1]; ey=height; }
                    else if (rgbXY[0][0]>=0 && rgbXY[0][1]<=0){ sx=rgbXY[0][0]; ex= width; sy=0; ey=height+rgbXY[0][1]; }
                    for(y=sy;y<ey;y++) {
                            for(x=sx;x<ex;x++)
                                    ip.putPixel(x, y, ((r[x-rgbXY[0][0]][y-rgbXY[0][1]] & 0xff) <<16)+ ((g[x][y] & 0xff) << 8) + (b[x][y] & 0xff));
                    }
            }

            else if (plane==1){
                    for(y=0;y<height;y++) {
                            for(x=0;x<width;x++)
                                    ip.putPixel(x,y, ((r[x][y] & 0xff) <<16)+ ((0 & 0xff) << 8) + (b[x][y] & 0xff));
                    }
                    if(rgbXY[1][0]>=0 && rgbXY[1][1]>=0) {sx=rgbXY[1][0]; ex= width; sy=rgbXY[1][1]; ey=height; }
                    else if (rgbXY[1][0]<=0 && rgbXY[1][1]<=0){ sx=0; ex= width+rgbXY[1][0]; sy=0; ey=height+rgbXY[1][1]; }
                    else if (rgbXY[1][0]<=0 && rgbXY[1][1]>=0){ sx=0; ex= width+rgbXY[1][0]; sy=rgbXY[1][1]; ey=height; }
                    else if (rgbXY[1][0]>=0 && rgbXY[1][1]<=0){ sx=rgbXY[1][0]; ex= width; sy=0; ey=height+rgbXY[1][1]; }
                    for(y=sy;y<ey;y++) {
                            for(x=sx;x<ex;x++)
                                    ip.putPixel(x, y, ((r[x][y] & 0xff) <<16)+ ((g[x-rgbXY[1][0]][y-rgbXY[1][1]] & 0xff) << 8) + (b[x][y] & 0xff));
                    }
            }
            else if (plane==2){
                    for(y=0;y<height;y++) {
                            for(x=0;x<width;x++)
                                    ip.putPixel(x,y, ((r[x][y] & 0xff) <<16)+ ((g[x][y] & 0xff) << 8) + (0 & 0xff));
                    }
                    if(rgbXY[2][0]>=0 && rgbXY[2][1]>=0) {sx=rgbXY[2][0]; ex= width; sy=rgbXY[2][1]; ey=height; }
                    else if (rgbXY[2][0]<=0 && rgbXY[2][1]<=0){ sx=0; ex= width+rgbXY[2][0]; sy=0; ey=height+rgbXY[2][1]; }
                    else if (rgbXY[2][0]<=0 && rgbXY[2][1]>=0){ sx=0; ex= width+rgbXY[2][0]; sy=rgbXY[2][1]; ey=height; }
                    else if (rgbXY[2][0]>=0 && rgbXY[2][1]<=0){ sx=rgbXY[2][0]; ex= width; sy=0; ey=height+rgbXY[2][1]; }
                    for(y=sy;y<ey;y++) {
                            for(x=sx;x<ex;x++){
                                    ip.putPixel(x, y, ((r[x][y] & 0xff) <<16)+ ((g[x][y] & 0xff) << 8) + (b[x-rgbXY[2][0]][y-rgbXY[2][1]] & 0xff));
                            }
                    }
            }
            imp.updateAndDraw();
    }

    void updatergb(){
            for(y=0;y<height;y++) {
                    for(x=0;x<width;x++){
                            pixel=ip.getPixel(x,y);
                            r[x][y]=((pixel & 0xff0000) >> 16);
                            g[x][y]=((pixel & 0x00ff00) >> 8);
                            b[x][y]=(pixel & 0x0000ff);
                    }
            }
    }
    public synchronized  void actionPerformed(ActionEvent e) {
        JButton tempButton = (JButton)e.getSource();
        actionPerform(tempButton);
            notify();
            align();
    }

    void actionPerform(JButton tempButton){

        if (tempButton == upButton){
            moveUp();
            }
            else if (tempButton == downButton){
            moveDown();
            }
            else if (tempButton == rightButton){
            moveLeft();
            }
            else if (tempButton == leftButton){
            moveRight();
            }
            else if (tempButton == revertButton){
                IJ.runPlugIn("ij.plugin.Commands", "revert");
                    imp = WindowManager.getCurrentImage();
                    ip = imp.getProcessor();
                    // get the 3 planes
                    for(y=0;y<height;y++) {
                            for(x=0;x<width;x++){
                                    pixel=ip.getPixel(x,y);
                                    r[x][y]=((pixel & 0xff0000) >> 16);
                                    g[x][y]=((pixel & 0x00ff00) >> 8);
                                    b[x][y]=(pixel & 0x0000ff);
                            }
                    }
                    rgbXY[0][0]=rgbXY[0][1]=rgbXY[1][0]=0;
                    rgbXY[1][1]=rgbXY[2][0]=rgbXY[2][1]=0;
                    rgbXYM[0][0]=rgbXYM[0][1]=rgbXYM[1][0]=0;
                    rgbXYM[1][1]=rgbXYM[2][0]=rgbXYM[2][1]=0;
                    rgbX[0]=rgbX[1]=rgbX[2]=(double)width;
                    rgbY[0]=rgbY[1]=rgbY[2]=(double)height;
                    for(int i=1; i< 4; i++)
                        alignhText[i].setText(""+0);
                    for(int i=1; i< 4; i++)
                        alignvText[i].setText(""+0);

                    flag[0] = 1;
                    flag[1] = 1;
                    flag[2] = 1;
            }
    }
    void moveUp(){
        if(param == 0)return;
        rgbXY[tempColor][1]-=param; // move up
        rgbXYM[tempColor][1]-=param;
        if(tempColor == 0){
            alignvText[1].setText("" + rgbXYM[tempColor][1]);
            vRGB[0]=rgbXYM[tempColor][1]/param;
        }
        else if(tempColor == 1){
            alignvText[2].setText("" + rgbXYM[tempColor][1]);
            vRGB[1]=rgbXYM[tempColor][1]/param;
        }
        else if(tempColor == 2){
            alignvText[3].setText("" + rgbXYM[tempColor][1]);
            vRGB[2]=rgbXYM[tempColor][1]/param;
        }
    }
    void moveDown(){
        if(param == 0)return;
        rgbXY[tempColor][1]+=param; // move dn
        rgbXYM[tempColor][1]+=param;
        if(tempColor == 0){
            alignvText[1].setText("" + rgbXYM[tempColor][1]);
            vRGB[0]=rgbXYM[tempColor][1]/param;
        }
        else if(tempColor == 1){
            alignvText[2].setText("" + rgbXYM[tempColor][1]);
            vRGB[1]=rgbXYM[tempColor][1]/param;
        }
        else if(tempColor == 2){
            alignvText[3].setText("" + rgbXYM[tempColor][1]);
            vRGB[2]=rgbXYM[tempColor][1]/param;
        }
    }
    void moveLeft(){
        if(param == 0)return;
        rgbXY[tempColor][0]+=param; // move right
        rgbXYM[tempColor][0]+=param;
        if(tempColor == 0){
            alignhText[1].setText("" + rgbXYM[tempColor][0]);
            hRGB[0]=rgbXYM[tempColor][0]/param;
        }
        else if(tempColor == 1){
            alignhText[2].setText("" + rgbXYM[tempColor][0]);
            hRGB[1]=rgbXYM[tempColor][0]/param;
        }
        else if(tempColor == 2){
            alignhText[3].setText("" + rgbXYM[tempColor][0]);
            hRGB[2]=rgbXYM[tempColor][0]/param;
        }
    }
    void moveRight(){
        if(param == 0)return;
        rgbXY[tempColor][0]-=param; // move left
        rgbXYM[tempColor][0]-=param;
        if(tempColor == 0){
            alignhText[1].setText("" + rgbXYM[tempColor][0]);
            hRGB[0]=rgbXYM[tempColor][0]/param;
        }
        else if(tempColor == 1){
            alignhText[2].setText("" + rgbXYM[tempColor][0]);
            hRGB[1]=rgbXYM[tempColor][0]/param;
        }
        else if(tempColor == 2){
            alignhText[3].setText("" + rgbXYM[tempColor][0]);
            hRGB[2]=rgbXYM[tempColor][0]/param;
        }
    }


    public void stateChanged(ChangeEvent e) {
     JSpinner spinner = (JSpinner)e.getSource();
     //System.out.println("spinner=" + spinner.getValue().toString());
     if(spinner == transParam)spinner = transParam;
     Double s = (Double)spinner.getValue();
     param = s.intValue();
    }

    public void itemStateChanged(ItemEvent e) {
        JCheckBox selBox = (JCheckBox) e.getItem();
        setFields(selBox);
        updatergb(); // update planes (out of frame image data is lost!)
    for(y=0;y<height;y++) {
            for(x=0;x<width;x++)
                    ip.putPixel(x,y, ((flag[0] * r[x][y] & 0xff)<<16 ) + ((flag[1] * g[x][y] & 0xff) << 8) + (flag[2] * b[x][y] & 0xff));
        }
        rgbXY[0][0]=0;
        rgbXY[0][1]=0;
        rgbXY[1][0]=0;
        rgbXY[1][1]=0;
        rgbXY[2][0]=0;
        rgbXY[2][1]=0;
        imp.updateAndDraw();
    }
    public void insertUpdate(DocumentEvent e){
        //textFieldUpdate(e);
    }
    public void removeUpdate(DocumentEvent e){
        //textFieldUpdate(e);
    }
    public void changedUpdate(DocumentEvent e){
    }

    void setFields(JCheckBox selBox){
        if(selBox == redCheckbox){
            tempColor=0;
            alignvText[0].setEditable(false);
            alignvText[1].setEnabled(true);
            alignvText[2].setEnabled(false);
            alignvText[3].setEnabled(false);
            alignhText[0].setEditable(false);
            alignhText[1].setEnabled(true);
            alignhText[2].setEnabled(false);
            alignhText[3].setEnabled(false);
        }
        else if(selBox == greenCheckbox){
            tempColor=1;
           alignvText[0].setEditable(false);
           alignvText[1].setEnabled(false);
           alignvText[2].setEnabled(true);
           alignvText[3].setEnabled(false);
           alignhText[0].setEditable(false);
           alignhText[1].setEnabled(false);
           alignhText[2].setEnabled(true);
           alignhText[3].setEnabled(false);
       }
        else if(selBox == blueCheckbox){
            tempColor=2;
            alignvText[0].setEditable(false);
            alignvText[1].setEnabled(false);
            alignvText[2].setEnabled(false);
            alignvText[3].setEnabled(true);
            alignhText[0].setEditable(false);
            alignhText[1].setEnabled(false);
            alignhText[2].setEnabled(false);
            alignhText[3].setEnabled(true);
        }
    }
    /**
      * Creates a <code>GridBagConstraint</code> object with
      * all of its fields set to their default value.
      */
     /*
         gridx = RELATIVE;
         gridy = RELATIVE;
         gridwidth = 1;
         gridheight = 1;

         weightx = 0;
         weighty = 0;
         anchor = CENTER;
         fill = NONE;

         insets = new Insets(0, 0, 0, 0);
         ipadx = 0;
         ipady = 0;

     */

    final private void addComponent(
    final JPanel panel,
    final int row, final int col,
    final int width, final int height,
    final double weightx,
    final double weighty,
    final int anchor,
    final int fill,
    final Insets insets,
    final int ipadx,
    final int ipady,
    final GridBagConstraints constraint,
    final GridBagLayout layout,
    final Component comp) {
            constraint.gridx = col;
            constraint.gridy = row;
            constraint.gridwidth = width;
            constraint.gridheight = height;
            constraint.weightx = weightx;
            constraint.weighty = weighty;
            constraint.anchor = anchor;
            constraint.fill = fill;
            constraint.insets = insets;
            constraint.ipadx = ipadx;
            constraint.ipady = ipady;
            layout.setConstraints(comp, constraint);
            panel.add(comp);
    }


}
