package ij2x.plugin;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Transparency;
import java.awt.Toolkit;

import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.RoundRectangle2D;

import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.PixelGrabber;

import java.net.URL;

import java.text.DateFormat;

import java.util.Date;
import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.border.Border;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.Prefs;
import ij.WindowManager;
import ij.plugin.PlugIn;
import ij.plugin.OverlayCommands;
import javax.swing.AbstractAction;
import javax.swing.Action;
import java.awt.RenderingHints;
import javax.swing.UIManager;
import javax.swing.UIDefaults;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ControlbarJPanel extends JPanel implements PlugIn, ActionListener, MouseListener, MouseMotionListener, Runnable{

    protected ImagePlus imp;
    protected ImageJ ij;
    private int offset=60, offsetHeight;
    public JButton infoButton, draggedButton, closeButton, undecoratedButton, action;
    protected JButton newButton, openButton, undoButton, copyButton, cutButton, pasteButton
            , clearButton, fillButton, drawButton, drawOverlayButton, removeOverlayButton, roicolorButton, colorpickerButton
            , selectButton, nonselectButton, showOverlayButton, hideOverlayButton
            , splineButton, duplicateButton, captureButton, rotateButton, clockButton, specifyButton;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray, Color.lightGray);
    private long mouseDownTime;
    private static int current;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;
    public JPanel controlBarPanel=new JPanel();
    public JLabel spaceLabel, clockLabel, label;
    public JPanel panel=new JPanel();
    protected Date date = new Date();

    private boolean running=false;
    private Thread timer;
    private String time;
    private DateFormat timeFormat;
    private static boolean isparent = false;
    private static ResourceBundle resources;
    private static String fileType = ".gif";
    private static String dir;
    private int index = 0;
    private static int ARRAYLENGTH = 20;
    private static int PARTSLENGTH = 3;

    static {
        try {
            resources = ResourceBundle.getBundle("ij2x.plugin.resources.ControlBarPanel",
                                                 Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("resources/ControlBarPanel.properties not found");
            System.exit(1);
        }
    }


    public ControlbarJPanel() {
        ij = IJ.getInstance();
        //dir = Prefs.getString("icondir");
        //controlBarPanel=createControlBar();
        timeFormat= DateFormat.getTimeInstance(DateFormat.DEFAULT);
        start();
}

    public void run(String arg){
        ij = IJ.getInstance();
        controlBarPanel=createControlBar();
        //timeFormat= DateFormat.getTimeInstance(DateFormat.DEFAULT);
        //start();
   }

    /*protected String getResourceString(String nm) {
        String str;
        try {
            str = resources.getString(nm);
        } catch (MissingResourceException mre) {
            str = null;
        }
        return str;
    }*/

    /*protected URL getResource(String key) {
         String name = getResourceString(key);
         if (name != null) {
             URL url = this.getClass().getResource(name);
             return url;
         }
         return null;
     }*/

     /**
      * Take the given string and chop it up into a series
      * of strings on whitespace boundaries.  This is useful
      * for trying to get an array of strings out of the
      * resource file.
      */
     /*protected String[] tokenize(String input) {
         Vector<String> v = new Vector<String>();
         StringTokenizer t = new StringTokenizer(input);
         String cmd[];

         while (t.hasMoreTokens())
             v.addElement(t.nextToken());
         cmd = new String[v.size()];
         for (int i = 0; i < cmd.length; i++)
             cmd[i] = v.elementAt(i);

         return cmd;
     }*/
     /**
      * Create the toolbar.  By default this reads the
      * resource file for the definition of the toolbar.
      */
     /*private Component createToolbar() {
         toolbar = new JToolBar();
         boolean isbutton=true;
         String[] toolKeys = tokenize(getResourceString("toolbar"));
         for (int i = 0; i < toolKeys.length; i++) {
             if (toolKeys[i].equals("-")) {
                 toolbar.add(Box.createHorizontalStrut(5));
             } else {
                 String bot= getResourceString(toolKeys[i] + "Button");
                 if(bot!=null){
                     Boolean shifts = Boolean.valueOf(bot);
                     isbutton = shifts.booleanValue();
                 }//else isbutton=false;
                 toolbar.add(createTool(toolKeys[i], isbutton));
             }
         }
         toolbar.add(Box.createHorizontalGlue());
         return toolbar;
     }*/


    public JPanel createControlBar(){

        java.awt.FlowLayout flayout = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flayout.setHgap(0);
        flayout.setVgap(0);
        panel.setLayout(flayout);
        panel.setBorder(lightGrayBorder);
        clockLabel=createLabel(clockLabel, "", "00:00:00");
        this.setDate(new Date());
        clockLabel.setBorder(lightGrayBorder);
        dir = Prefs.getString("icondir");

        //toolbar= image open undo copy cut paste clear fill draw duplicate selectall deselect fitspline threecolor jcolopicker cupture info  rotate scale spezifyroi
        //          0      1    2    3   4    5     6     7    8      9        10        11       12        13          14          15    16    17     18     19

        // This code ensures that all the pixels in the image are loaded
        Image allImage = ((ImageIcon)createIcon("i_commandbar")).getImage();
        BufferedImage[][] allBi = splitAll(allImage, ARRAYLENGTH, PARTSLENGTH, true);

        newButton=createButton(newButton, "New Image", allBi[index++]);

        openButton=createButton(openButton, "Open Image", allBi[index++]);

        undoButton=createButton(undoButton, "Undo Action", allBi[index++]);

        copyButton=createButton(copyButton, "Copy Shape", allBi[index++]);

        cutButton=createButton(cutButton, "Cut Shape", allBi[index++]);

        pasteButton=createButton(pasteButton, "Paste Shape", allBi[index++]);

        clearButton=createButton(clearButton, "Clear Shape", allBi[index++]);

        fillButton=createButton(fillButton, "Fill Shape", allBi[index++]);

        drawButton=createButton(drawButton, "Draw Shape", allBi[index++]);

        duplicateButton=createButton(duplicateButton, "Duplicate Image", allBi[index++]);

        selectButton=createButton(selectButton, "Select Image", allBi[index++]);

        nonselectButton=createButton(nonselectButton, "Non Select Image", allBi[index++]);

        splineButton=createButton(splineButton, "Fit Spline", allBi[index++]);

        roicolorButton=createButton(roicolorButton, "Shape Color", allBi[index++]);

        colorpickerButton=createButton(colorpickerButton, "JColor Picker", allBi[index++]);

        captureButton=createButton(captureButton, "Capture Screen", allBi[index++]);

        infoButton=createButton(infoButton, "Show Info", allBi[index++]);

        rotateButton=createButton(rotateButton, "Rotate Arbitrarily", allBi[index++]);

        clockButton=createButton(clockButton, "Digital Clock", allBi[index++]);

        specifyButton=createButton(specifyButton, "Spezify Roi", allBi[index]);

        drawOverlayButton=createButton(drawOverlayButton, "Add Overlay", null);
        ImageIcon aio = (ImageIcon)createIcon("s_opencil");
        ImageIcon biio = (ImageIcon)createIcon("kachel/gif_24x24/leer_red_24x24");
        ImageIcon b1iio = (ImageIcon)createIcon("kachel/gif_24x24/leer_blue_24x24_01");
        ImageIcon b2iio = (ImageIcon)createIcon("kachel/gif_24x24/leer_24x24_01");
        ImageIcon b3iio = (ImageIcon)createIcon("kachel/gif_24x24/leer_yellow_24x24_01");
        //drawOverlayButton.setIcon(createIcon("kachel/s_leer32x32"));
        //drawOverlayButton.setRolloverIcon(createIcon("kachel/s_leer_ro32x32"));
        //drawOverlayButton.setPressedIcon(createIcon("kachel/s_leer_press32x32"));
        drawOverlayButton.setIcon(createBufferedIcon("kachel/s_bevel_leer", biio.getImage(), aio.getImage()));
        drawOverlayButton.setRolloverIcon(createBufferedIcon("kachel/s_bevel_ro", biio.getImage(), aio.getImage()));
        drawOverlayButton.setPressedIcon(createBufferedIcon("kachel/s_bevel_press", biio.getImage(), aio.getImage()));

        removeOverlayButton=createButton(removeOverlayButton, "Remove Overlay", null);
        //removeOverlayButton.setIcon(createIcon("s_ropencil"));
        //removeOverlayButton.setRolloverIcon(createIcon("s_ropencil_ro"));
        //removeOverlayButton.setPressedIcon(createIcon("s_ropencil_press"));
        ImageIcon rio = (ImageIcon)createIcon("s_ropencil");
        //drawOverlayButton.setIcon(createIcon("kachel/s_leer32x32"));
        //drawOverlayButton.setRolloverIcon(createIcon("kachel/s_leer_ro32x32"));
        //drawOverlayButton.setPressedIcon(createIcon("kachel/s_leer_press32x32"));
        //removeOverlayButton.setIcon(createBufferedIcon("kachel/s_leer32x32", iiro.getImage()));
        //removeOverlayButton.setRolloverIcon(createBufferedIcon("kachel/s_leer_ro32x32", iiro.getImage()));
        //removeOverlayButton.setPressedIcon(createBufferedIcon("kachel/s_leer_press32x32", iiro.getImage()));
        removeOverlayButton.setIcon(createBufferedIcon("kachel/s_bevel_leer", b1iio.getImage(), rio.getImage()));
        removeOverlayButton.setRolloverIcon(createBufferedIcon("kachel/s_bevel_ro", b1iio.getImage(), rio.getImage()));
        removeOverlayButton.setPressedIcon(createBufferedIcon("kachel/s_bevel_press", b1iio.getImage(), rio.getImage()));
        showOverlayButton=createButton(showOverlayButton, "Show Overlay", null);
        ImageIcon sio = (ImageIcon)createIcon("s_sopencil");
        showOverlayButton.setIcon(createBufferedIcon("kachel/s_bevel_leer", b2iio.getImage(), sio.getImage()));
        showOverlayButton.setRolloverIcon(createBufferedIcon("kachel/s_bevel_ro", b2iio.getImage(), sio.getImage()));
        showOverlayButton.setPressedIcon(createBufferedIcon("kachel/s_bevel_press", b2iio.getImage(), sio.getImage()));
        ImageIcon hio = (ImageIcon)createIcon("s_hopencil");
        hideOverlayButton=createButton(hideOverlayButton, "Hide Overlay", null);
        hideOverlayButton.setIcon(createBufferedIcon("kachel/s_bevel_leer", b3iio.getImage(), hio.getImage()));
        hideOverlayButton.setRolloverIcon(createBufferedIcon("kachel/s_bevel_ro", b3iio.getImage(), hio.getImage()));
        hideOverlayButton.setPressedIcon(createBufferedIcon("kachel/s_bevel_press", b3iio.getImage(), hio.getImage()));

        spaceLabel = new JLabel("", JLabel.CENTER);
        offsetHeight=(int)infoButton.getPreferredSize().getHeight();
        spaceLabel.setMinimumSize(new Dimension(offset, offsetHeight));
        spaceLabel.setMaximumSize(new Dimension(offset, offsetHeight));
        spaceLabel.setPreferredSize(new Dimension(offset, offsetHeight));
        spaceLabel.setBorder(lightGrayBorder);
        panel.add(newButton);
        panel.add(openButton);
        panel.add(undoButton);
        panel.add(copyButton);
        panel.add(cutButton);
        panel.add(pasteButton);
        panel.add(clearButton);
        panel.add(fillButton);
        panel.add(drawButton);
        panel.add(drawOverlayButton);
        panel.add(removeOverlayButton);
        panel.add(showOverlayButton);
        panel.add(hideOverlayButton);
        panel.add(roicolorButton);
        panel.add(colorpickerButton);
        panel.add(specifyButton);
        panel.add(selectButton);
        panel.add(nonselectButton);
        panel.add(splineButton);
        panel.add(duplicateButton);
        panel.add(captureButton);
        panel.add(infoButton);
        panel.add(clockButton);

        JPanel stbPanel = new JPanel();
        stbPanel.setLayout(new BorderLayout());
        stbPanel.add(BorderLayout.WEST, panel);
        //stbPanel.add(BorderLayout.CENTER, spaceLabel);
        //stbPanel.add(BorderLayout.EAST, clockLabel);
        return stbPanel;
     }
     private JLabel createLabel(JLabel label, String tooltip, String text){
         label = new JLabel(text);
         label.setToolTipText(tooltip);
         label.addMouseListener(new MouseListener(){
         public void mousePressed(MouseEvent e){
             if (!e.isMetaDown()){
                 labelEvent(e);
             }
         }
         public void mouseReleased(MouseEvent e) {}
         public void mouseExited(MouseEvent e) {}
         public void mouseClicked(MouseEvent e) {}
         public void mouseEntered(MouseEvent e) {}
         });
     return label;
     }

     public void labelEvent(MouseEvent e){
         JLabel label = (JLabel)e.getSource();
         JFrame[] editFrame = WindowManager.getNonImageWindows();
         if(editFrame.length > 1){
             for (int i = 0; i < editFrame.length; i++) {
                 //IJ.log("" + editFrame[i].getClass().getName());
                 if (editFrame[i].getClass().getName().equals(
                         "com.ibm.JCalendar")) {
                     isparent = true;
                     editFrame[i].setVisible(false);
                     WindowManager.removeWindow(editFrame[i]);
                 } else
                     isparent = false;
             }
         }else
         if (editFrame.length == 1 && editFrame[0].getClass().getName().equals(
                 "com.ibm.JCalendar")) {
             isparent = true;
             editFrame[0].setVisible(false);
             WindowManager.removeWindow(editFrame[0]);
         }else isparent = false;
        if(label==clockLabel && !isparent){
           IJ.runPlugIn("com.ibm.JCalendar", "");
       }
     }
     private JButton createButton(JButton action, String tooltip, BufferedImage[] image){
          action = new JButton();
            action.setToolTipText(tooltip);
             action.addActionListener(this);
                 action.addMouseListener(this);
             action.addMouseMotionListener(this);
            setBorderlessButton(action);
           if(image != null)
              setIcon(action, image);
     return action;
     }


     private Icon createIcon(String key){
         Icon icon = null;
         String fileName=key + getFileType();
         if(getImageDir() == null){
            dir="images/";
         }
         String path = getImageDir()+fileName;
        try {
            URL url = this.getClass().getResource(path);
            Image image = Toolkit.getDefaultToolkit().createImage(url);
            if (url != null) {
                icon = new ImageIcon(image);
              }
            } catch (Exception ex) {
          }
            return icon;
     }

     private Icon createBufferedIcon(String key, Image bgImage){
         Icon icon = null;
         String fileName=key + getFileType();
         if(getImageDir() == null){
            dir="images/";
         }
         String path = getImageDir()+fileName;
        try {
            URL url = this.getClass().getResource(path);
            Image image = Toolkit.getDefaultToolkit().createImage(url);
            if (url != null && bgImage != null) {
                BufferedImage bimage = toBufferedImage(image, bgImage);
                icon = new ImageIcon(bimage);
              }
            } catch (Exception ex) {
          }
            return icon;
     }
     private Icon createBufferedIcon(String key, Image bgImage, Image imageIcon){
         Icon icon = null;
         String fileName=key + getFileType();
         if(getImageDir() == null){
            dir="images/";
         }
         String path = getImageDir()+fileName;
        try {
            URL url = this.getClass().getResource(path);
            Image image = Toolkit.getDefaultToolkit().createImage(url);
            if (url != null && bgImage != null) {
                BufferedImage bimage = toBufferedImage(image, bgImage, imageIcon);
                icon = new ImageIcon(bimage);
              }
            } catch (Exception ex) {
          }
            return icon;
     }

     private String getFileType(){
            return fileType;
     }
     private String getImageDir(){
            return dir;
     }
     private void setIcon(JButton action, BufferedImage[] image){
           action.setIcon(new ImageIcon(image[0]));
             action.setRolloverIcon(new ImageIcon(image[1]));
           action.setPressedIcon(new ImageIcon(image[2]));
     }
     /**
      * Splits an image into count subimages.
      */
     public static BufferedImage[] split(Image image, int count, boolean isHorizontal) {
         BufferedImage src = toBufferedImage(image);
         if (count == 1) {
             return new BufferedImage[]{src};
         }

         BufferedImage[] parts = new BufferedImage[count];
         for (int i = 0; i < count; i++) {
             if (isHorizontal) {
                 parts[i] = src.getSubimage(
                         src.getWidth() / count * i, 0,
                         src.getWidth() / count, src.getHeight());
             } else {
                 parts[i] = src.getSubimage(
                         0, src.getHeight() / count * i,
                         src.getWidth(), src.getHeight() / count);
             }
         }
         return parts;
     }

     /**
      * Splits an image into count subimages.
      */
     public static BufferedImage[][] splitAll(Image image, int arraycount, int count, boolean isHorizontal) {
         BufferedImage src = toBufferedImage(image);
         BufferedImage[] ssrc = split(src, 20, true);
         BufferedImage[][] parts = new BufferedImage[arraycount][count];
         for (int i = 0; i < arraycount; i++) {
             for (int j = 0; j < count; j++) {
                 if (isHorizontal) {
                     //System.out.println("["+i+"]"+"["+j+"]");
                     parts[i][j] = ssrc[i].getSubimage(
                             ssrc[i].getWidth() / count * j, 0,
                             ssrc[i].getWidth() / count, src.getHeight());
                 } else {
                     parts[i][j] = ssrc[i].getSubimage(
                             0, ssrc[i].getHeight() / count * j,
                             src.getWidth(), ssrc[i].getHeight() / count);
                 }
             }

         }return parts;
     }
     public static BufferedImage toBufferedImage(Image image) {
         if (image instanceof BufferedImage) {
             return (BufferedImage) image;
         }

         // Create a buffered image with a format that's compatible with the screen
         BufferedImage bimage = null;

             // Determine if the image has transparent pixels; for this method's
             // implementation, see e661 Determining If an Image Has Transparent Pixels
             boolean hasAlpha=false;
             try {
                 //hasAlpha = hasAlpha(image);
                 hasAlpha = true;
            } catch (IllegalAccessError e) {
                 // If we can't determine this, we assume that we have an alpha,
                 // in order not to loose data.
             }

             if (bimage == null) {
                 // Create a buffered image using the default color model
                 int type = BufferedImage.TYPE_INT_RGB;
                 if (hasAlpha) {
                     type = BufferedImage.TYPE_INT_ARGB;
                 }
                 bimage = new BufferedImage(image.getWidth(null), image.getHeight(null), type);
             }

         // Copy image to buffered image
         Graphics g = bimage.createGraphics();

         // Paint the image onto the buffered image
         g.drawImage(image, 0, 0, null);
         g.dispose();

         return bimage;
     }
     public static BufferedImage toBufferedImage(Image image, Image icon) {
         if (image instanceof BufferedImage) {
             return (BufferedImage) image;
         }

         // This code ensures that all the pixels in the image are loaded
         image = new ImageIcon(image).getImage();
         icon = new ImageIcon(icon).getImage();

         // Create a buffered image with a format that's compatible with the screen
         BufferedImage bimage = null;
             // Determine if the image has transparent pixels; for this method's
             // implementation, see e661 Determining If an Image Has Transparent Pixels
             boolean hasAlpha;
             try {
                 hasAlpha = hasAlpha(image);
             } catch (IllegalAccessError e) {
                 // If we can't determine this, we assume that we have an alpha,
                 // in order not to loose data.
                 hasAlpha = true;
             }

             GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
             try {
                 // Determine the type of transparency of the new buffered image
                 int transparency = Transparency.OPAQUE;
                 if (hasAlpha) {
                     transparency = Transparency.TRANSLUCENT;
                 }

                 // Create the buffered image
                 GraphicsDevice gs = ge.getDefaultScreenDevice();
                 GraphicsConfiguration gc = gs.getDefaultConfiguration();
                 bimage = gc.createCompatibleImage(
                         image.getWidth(null), image.getHeight(null), transparency);
             } catch (Exception e) {
                 //} catch (HeadlessException e) {
                 // The system does not have a screen
             }

             if (bimage == null) {
                 // Create a buffered image using the default color model
                 int type = BufferedImage.TYPE_INT_RGB;
                 if (hasAlpha) {
                     type = BufferedImage.TYPE_INT_ARGB;
                 }
                 bimage = new BufferedImage(image.getWidth(null), image.getHeight(null), type);
             }

         // Copy image to buffered image
         Graphics g = bimage.createGraphics();

         // Paint the image onto the buffered image
         g.drawImage(image, 0, 0, null);
         g.drawImage(icon, 8, 8, null);
         g.dispose();

         return bimage;
     }
     public static BufferedImage toBufferedImage(Image borderImage, Image bgImage, Image imageIcon) {
         if (borderImage instanceof BufferedImage) {
             return (BufferedImage) borderImage;
         }

         // This code ensures that all the pixels in the image are loaded
         borderImage = new ImageIcon(borderImage).getImage();
         bgImage = new ImageIcon(bgImage).getImage();
         imageIcon = new ImageIcon(imageIcon).getImage();

         // Create a buffered image with a format that's compatible with the screen
         BufferedImage bimage = null;

             // Determine if the image has transparent pixels; for this method's
             // implementation, see e661 Determining If an Image Has Transparent Pixels
             boolean hasAlpha;
             try {
                 hasAlpha = hasAlpha(borderImage);
             } catch (IllegalAccessError e) {
                 // If we can't determine this, we assume that we have an alpha,
                 // in order not to loose data.
                 hasAlpha = true;
             }

             GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
             try {
                 // Determine the type of transparency of the new buffered image
                 int transparency = Transparency.OPAQUE;
                 if (hasAlpha) {
                     transparency = Transparency.TRANSLUCENT;
                 }

                 // Create the buffered image
                 GraphicsDevice gs = ge.getDefaultScreenDevice();
                 GraphicsConfiguration gc = gs.getDefaultConfiguration();
                 bimage = gc.createCompatibleImage(
                         borderImage.getWidth(null), borderImage.getHeight(null), transparency);
             } catch (Exception e) {
             }

             if (bimage == null) {
                 // Create a buffered image using the default color model
                 int type = BufferedImage.TYPE_INT_RGB;
                 if (hasAlpha) {
                     type = BufferedImage.TYPE_INT_ARGB;
                 }
                 bimage = new BufferedImage(borderImage.getWidth(null), borderImage.getHeight(null), type);
             }

         // Copy image to buffered image
         Graphics2D g2d = bimage.createGraphics();
         UIDefaults uid = UIManager.getLookAndFeel().getDefaults();
         Color osColor = uid.getColor("Panel.background");
         g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
         g2d.setColor(Color.white);
         RoundRectangle2D.Double rect2D = new RoundRectangle2D.Double(0.0, 0.0, (double)borderImage.getWidth(null), (double)borderImage.getHeight(null), 8.0, 8.0);
         //g2d.draw3DRect(0, 0, borderImage.getWidth(null), borderImage.getHeight(null), true);
         g2d.fill(rect2D);
         g2d.setColor(osColor.darker());
         rect2D = new RoundRectangle2D.Double(1.0, 1.0, (double)borderImage.getWidth(null)-2.0, (double)borderImage.getHeight(null)-2.0, 8.0, 8.0);
         g2d.fill(rect2D);
         g2d.setColor(osColor);
         rect2D = new RoundRectangle2D.Double(2.0, 2.0, (double)borderImage.getWidth(null)-4.0, (double)borderImage.getHeight(null)-4.0, 8.0, 8.0);
         g2d.fill(rect2D);
         // Paint the images onto the buffered image
         //g.drawImage(borderImage, 0, 0, null);
         g2d.drawImage(bgImage, 4, 4, null);
         g2d.drawImage(imageIcon, 8, 8, null);
         g2d.dispose();

         return bimage;
     }
     /**
      * This method returns true if the specified image has transparent pixels
      *
      * Code taken from the Java Developers Almanac 1.4
      * http://javaalmanac.com/egs/java.awt.image/HasAlpha.html
      */
     public static boolean hasAlpha(Image image) {
         // If buffered image, the color model is readily available
         if (image instanceof BufferedImage) {
             BufferedImage bimage = (BufferedImage) image;
             return bimage.getColorModel().hasAlpha();
         }

         // Use a pixel grabber to retrieve the image's color model;
         // grabbing a single pixel is usually sufficient
         PixelGrabber pg = new PixelGrabber(image, 0, 0, 1, 1, false);
         try {
             pg.grabPixels();
         } catch (InterruptedException e) {
         }

         // Get the image's color model
         // We must check for null here, because the pixel grabber
         // may not have been able to retrieve the color model.
         ColorModel cm = pg.getColorModel();
         return (cm != null) ? cm.hasAlpha() : false;
     }
     void setButtonDim(JButton action, Dimension maxDim, Dimension preDim, Dimension minDim){
           action.setMaximumSize(maxDim);
           action.setPreferredSize(preDim);
           action.setMinimumSize(minDim);
   }

     void setBorderlessButton(JButton button){
           button.setMargin(new Insets(0, 0, 0, 0));
           button.setBorderPainted(false);
           button.setContentAreaFilled(false);
           button.setFocusPainted(false);
       }

       public void mousePressed(MouseEvent e) {
           action = (JButton)e.getSource();
           int x = e.getX();
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (!doubleClick) {
                }
        }

        public void mouseReleased(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}

        public void mouseDragged(MouseEvent e) {}
        public void mouseMoved(MouseEvent e) {
            JButton action = (JButton)e.getSource();
            int x = e.getX();
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 if (!false) {
                     if(action == infoButton){
                         IJ.showStatus("Command: Show Info...");
                     }
                     else if(action == openButton){
                         IJ.showStatus("Command: Open...");
                     }
                     else if(action == newButton){
                         IJ.showStatus("Command: Image...");
                     }
                     else if(action == undoButton){
                         IJ.showStatus("Command: Undo");
                     }
                     else if(action == copyButton){
                         IJ.showStatus("Command: Copy");
                     }
                     else if(action == cutButton){
                         IJ.showStatus("Command: Cut");
                     }
                     else if(action == pasteButton){
                         IJ.showStatus("Command: Paste");
                     }
                     else if(action == clearButton){
                         IJ.showStatus("Command: Clear");
                     }
                     else if(action == fillButton){
                         IJ.showStatus("Command: Fill");
                     }
                     else if(action == drawButton){
                         IJ.showStatus("Command: Draw");
                     }
                     else if(action == duplicateButton){
                         IJ.showStatus("Command: Duplicate...");
                     }
                     /*else if(action == scaleButton){
                         IJ.showStatus("Command: Scale...");
                     }*/
                     else if(action == selectButton){
                         IJ.showStatus("Command: Select All");
                     }
                     else if(action == nonselectButton){
                         IJ.showStatus("Select None");
                     }
                     /*else if(action == rotateButton){
                         IJ.showStatus("Command: Arbitrarily...");
                     }*/
                     else if(action == splineButton){
                         IJ.showStatus("Command: Fit Spline");
                     }
                     else if(action == roicolorButton){
                             IJ.showStatus("Command: Roi Color");
                     }
                     else if(action == colorpickerButton){
                         IJ.showStatus("Command: JColor Picker...");
                     }
                     else if(action == captureButton){
                         IJ.showStatus("Command: Capture Screen ");
                     }
                     else if (action == draggedButton) {
                         IJ.showStatus("Move...");
                     }
                     else if (action == closeButton) {
                         IJ.showStatus("Decorated Frame");
                     }
                     else if (action == undecoratedButton) {
                         IJ.showStatus("Undecorated Frame");
                     }

                 }
        }
        // Action listener method
        public void actionPerformed(ActionEvent e){
            try {
                if(action == infoButton){
                    IJ.doCommand("Show Info...");
                }
                else if(action == openButton){
                    IJ.doCommand("Open...");
                }
                else if(action == newButton){
                    IJ.doCommand("Image...");
                    //IJ.run("Image...", "");
                }
                else if(action == undoButton){
                    IJ.doCommand("Undo");
                }
                else if(action == copyButton){
                    IJ.doCommand("Copy");
                }
                else if(action == cutButton){
                    IJ.doCommand("Cut");
                }
                else if(action == pasteButton){
                    IJ.doCommand("Paste");
                }
                else if(action == clearButton){
                    IJ.doCommand("Clear");
                }
                else if(action == fillButton){
                    IJ.doCommand("Fill");
                }
                else if(action == drawButton){
                    IJ.doCommand("Draw");
                }
                else if(action == drawOverlayButton){
                    //OverlayCommands.addSelection();
                    IJ.doCommand("Add Selection...");
                }
                else if(action == removeOverlayButton){
                    //OverlayCommands.remove();
                    IJ.doCommand("Remove Overlay");
                }
                else if(action == duplicateButton){
                    IJ.doCommand("Duplicate...");
                }
                else if(action == selectButton){
                    IJ.doCommand("Select All");
                }
                else if(action == nonselectButton){
                    IJ.doCommand("Select None");
                }
                else if(action == splineButton){
                    IJ.doCommand("Fit Spline");
                }
                else if(action == colorpickerButton){
                    if(!IJ.isWindows()){
                        IJ.runPlugIn("ij2x.plugin.frame.JColorPicker", "");
                    }else{
                        IJ.runPlugIn("ij2x.plugin.frame.JColorPicker", "");
                    }
                }
                else if(action == roicolorButton){
                        IJ.runPlugIn("ij2x.plugin.ThreeColor","");
                }
                else if(action == captureButton){
                    IJ.doCommand("Capture Screen");
                }
                else if(action == specifyButton){
                    IJ.doCommand("Specify...");
                }
                else if(action == clockButton){
                    JFrame[] editFrame = WindowManager.getNonImageWindows();
                    if(editFrame.length > 1){
                        for (int i = 0; i < editFrame.length; i++) {
                            //IJ.log("" + editFrame[i].getClass().getName());
                            if (editFrame[i].getClass().getName().equals(
                                    "ij2x.plugin.frame.JCalendar")) {
                                isparent = true;
                                editFrame[i].setVisible(false);
                                WindowManager.removeWindow(editFrame[i]);
                            } else
                                isparent = false;
                        }
                    }else
                    if (editFrame.length == 1 && editFrame[0].getClass().getName().equals(
                            "ij2x.plugin.frame.JCalendar")) {
                        isparent = true;
                        editFrame[0].setVisible(false);
                        WindowManager.removeWindow(editFrame[0]);
                    }else isparent = false;
                   if(!isparent){
                      IJ.runPlugIn("ij2x.plugin.frame.JCalendar", "");
                  }
                }
            } catch (Exception ex) {

            }
        }

        public static final String cutAction = "cut";
        public static final String copyAction = "copy";
        public static final String openAction = "open";
        private Action[] defaultActions = {
                                          new CopyAction(),
                                          new CutAction(),
                                          new OpenAction()
        };

        class OpenAction extends AbstractAction {

            OpenAction() {
                super(openAction);
            }

            public void actionPerformed(ActionEvent e) {
                IJ.doCommand("Open...");
            }
        }

        class CopyAction extends AbstractAction {

            CopyAction() {
                super(copyAction);
            }

            public void actionPerformed(ActionEvent e) {
                IJ.doCommand("Copy");
            }
        }

        class CutAction extends AbstractAction {

            CutAction() {
                super(cutAction);
            }

            public void actionPerformed(ActionEvent e) {
                IJ.doCommand("Cut");
            }
        }


        public void setDate(Date date) {
            this.date = date;
        }

        /* geter methods for the timeFormat value*/
        public String getTimeFormatToString() {
            return time;
        }

        /* seter methods for the timeFormat value*/
        public void setTimeFormatToString(String time) {
            this.time = time;
        }

        /* interface Runnable methods */
        public void start() {
            running = true;
            if (timer == null)
                timer = new Thread(this);
            timer.start();
        }

        public void stop() {
            timer = null;
            notify();
        }

        public void run() {
            while (running) {
                String tFormat = timeFormat.format(new Date());
                setTimeFormatToString(tFormat);
                this.setDate(new Date());
                try {
                    Thread.sleep(100);
                    if(clockLabel != null){
                        clockLabel.setText(tFormat);
                        clockLabel.setToolTipText("Die Zeit:" + tFormat);
                        if(clockButton != null)
                        clockButton.setToolTipText("Die Zeit:" + tFormat);
                    }
                 } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            timer = null;
        }

}
