package ij2x.plugin;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import java.awt.image.ColorModel;
import java.awt.image.BufferedImage;
import java.awt.image.ImageProducer;
import java.awt.image.IndexColorModel;
import java.awt.image.MemoryImageSource;

import java.beans.Beans;
import java.net.URL;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.ButtonGroup;
import javax.swing.JComponent;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.UIDefaults;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.SwingUtilities;

import javax.swing.border.BevelBorder;
import javax.swing.border.Border;

import ij.ImagePlus;
import ij.process.ImageProcessor;
import ij.WindowManager;
import ij.gui.Roi;
import ij.gui.GenericDialog;
import ij.IJ;
import ij.ImageJ;
import ij.Prefs;
import ij.io.FileInfo;
import ij.process.ByteProcessor;
import ij.process.ImageStatistics;
import ij.measure.Measurements;
import ij.plugin.PlugIn;

import ij2x.gui.ColorChooser;
import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;
import ij2x.util.ResourceString;
import ij2x.util.BorderlessButton;
import ij2x.util.AWTImages;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) </p>
 * <p>Company: </p>
 * @author unbekannt
 * @version 1.0
 */

public class HorizontalGradient extends JComponent implements PlugIn, ItemListener, ActionListener{

  private BorderLayout borderLayout1;

  protected static Color settingColor=Color.white;
  protected Color oldsettingColor;
  protected JPanel colorPane;
  protected JPanel colorPanel;
  protected JPanel palettePanel;

  protected GridBagLayout gridBagLayout1;
  protected JPanel[] jPanel = new JPanel[12];
  public JLabel tempLabel;
  public String colorHex;
  protected int maxColumn = 30;
  protected Border border1;
  protected String[] curstringRGB = new String[3];
  protected GridBagLayout gridBagLayout2 = new GridBagLayout();
  protected BorderLayout borderLayout2;
  protected BorderLayout borderLayout3;
  protected boolean pressed = true;
  public ColorIcon icon;
  public String[] stringRGB;
  private ColorIconArea colorIconArea = null;
  public ImagePlus imp;
  private ImageProcessor ip;
  private Vector<JComponent> checkBox, lutCheckBox;
  private static int tempColor=0, index, lutColorIndex;
  private static int rowIndex=3;
  private static int colorIndex=8;
  private Color[] lutColor = new Color[colorIndex*rowIndex];
  private JCheckBox[] checkBoxes = new JCheckBox[lutColor.length*2];
  private JButton ccButton, resetButton, saveAsJavaButton, compilerunButton;
  private ButtonGroup group;
  private boolean background;
  public boolean isShowing=false;
  public boolean isLUT = false;
  private static boolean isRoiChecked=true, isFGChecked=false, isBGChecked=false;
  private static HorizontalGradient instance;
  private ImageJ ij;
  private Image image;
  private long mouseDownTime;
  public static final int DOUBLE_CLICK_THRESHOLD = 650;
  private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
  private Border grayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.gray, Color.lightGray);
  private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.LOWERED, Color.lightGray, Color.lightGray);
  //private JButton ccButton;
  private String[] names = new String[lutColor.length*2];
  private boolean[] lutChecked= new boolean[lutColor.length*2];
  private GenericDialog gd;
  private static boolean colorDialog=false;
  private boolean lutDialog=false;
  private FileInfo fi;
  private GradientPlot plot = new GradientPlot();
  private static ResourceBundle resources;
  private int indexes = 0;

  static {
      try {
          resources = ResourceBundle.getBundle("ij2x.plugin.resources.HGradient",
                                               Locale.getDefault());
      } catch (MissingResourceException mre) {
          System.err.println("resources/HGradient.properties not found");
          System.exit(1);
      }
  }


  public static HorizontalGradient getInstance(){
     if(instance == null) instance=new HorizontalGradient();
  return instance;
  }

  public void run(String arg){
      try {
          ij = IJ.getInstance();
          if(arg != null && arg.equals("isLUT")){
              isLUT = true;index=1;
          }
          if(tempColor==0){
              settingColor = Roi.getColor();
          }
          jbInit();
          if (!showDialog()){
              return;
          }
              else{
                  gradientShow();
              }
      } catch (Exception ex) {}
  }
  boolean showDialog() {
     boolean colorOrLut=true;
     group = new ButtonGroup();
     gd = new GenericDialog("");
     switch(index){
     case 0:
         break;
     case 1:
         colorOrLut = lutGUI(gd);
         break;
     }
     return colorOrLut;
  }

  boolean lutGUI(GenericDialog gd){
      ImagePlus imp = WindowManager.getCurrentImage();
      if(imp == null)IJ.error(" there are no images open ");
      else if (imp.getType() == ImagePlus.COLOR_RGB){
          IJ.error(
                  "Color tables cannot be assiged to RGB Images.");
      }
      plot.setHistogram(imp);
      fi = getLUT();
      if (lutDialog) {
              gd.toFront();
              return false;
      }
      for(int i=0; i < lutColor.length*2; i++){
         names[i] ="";
         lutChecked[i]=false;
      }
      lutDialog = true;
      gd.setTitle("Large Gradient");
      JLabel rgbLabel = new JLabel(" Horizontal Gradient ");
      JPanel rgbPanel = new JPanel();
      rgbPanel.add(rgbLabel);
      JLabel defineColorLabel = new JLabel(" DC:");
      defineColorLabel.setToolTipText("Define Color");
      defineColorLabel.setBorder(lightGrayBorder);
      rgbLabel.setBorder(grayBorder);
      gd.addPanel(rgbPanel, GridBagConstraints.WEST, new Insets(0, 0, 0, 10));
      JPanel buttonPanel=new JPanel();

      AWTImages.setImageDir("lutDir");

      String[] iconAllName = ResourceString.tokenize(ResourceString.getResourceString(resources, "hgradient"));

      Image[][] icons = new Image[iconAllName.length][3];
     try {
         for (int i = 0; i < iconAllName.length; i++) {
             for (int j = 0; j < 3; j++) {
                 icons[i][j] = ((ImageIcon) AWTImages.createIcon(
                         this,
                         ResourceString.tokenize(ResourceString.
                         getResourceString(resources, iconAllName[i]))[
                         j])).getImage();
             }
         }
     } catch (Exception ex) {
         ex.printStackTrace();
     }


      ccButton=BorderlessButton.createButton(this, ccButton, "Color Chooser", icons[indexes++]);

      resetButton=BorderlessButton.createButton(this, resetButton, "Deselect CheckBox", icons[indexes++]);

      saveAsJavaButton=BorderlessButton.createButton(this, saveAsJavaButton, "Save As Java", icons[indexes++]);

      compilerunButton=BorderlessButton.createButton(this, compilerunButton, "Compile And Run", icons[indexes++]);

      buttonPanel.setLayout(new GridLayout(1,4, 5, 0));
      buttonPanel.add(ccButton);
      buttonPanel.add(resetButton);
      buttonPanel.add(saveAsJavaButton);
      buttonPanel.add(compilerunButton);
      buttonPanel.setBorder(lightGrayBorder);

      JPanel thresholdPanel = new JPanel();
      thresholdPanel.add(plot);
      thresholdPanel.setBorder(lightGrayBorder);
      gd.addPanel(thresholdPanel, GridBagConstraints.CENTER, new Insets(0, 0, 0, 0));
      JPanel colorCheckBoxPanel=new JPanel();

      colorCheckBoxPanel.add(gd.addCheckboxGroupPanel(rowIndex, checkBoxes.length, names, lutChecked));
      JPanel control = new JPanel();
      control.add(colorCheckBoxPanel);
      colorCheckBoxPanel.setBorder(lightGrayBorder);
      JPanel bap = new JPanel();
      bap.add(palettePanel);
      bap.setBorder(lightGrayBorder);
      gd.addPanel(control, GridBagConstraints.CENTER, new Insets(0, 0, 0, 0));
      gd.addPanel(buttonPanel, GridBagConstraints.WEST, new Insets(0, 10, 0, 0));
      gd.addPanel(bap, GridBagConstraints.CENTER, new Insets(5, 5, 5, 5));
      lutCheckBox=gd.getCheckboxes();
      for(int i=0; i < lutColor.length; i++){
          checkBoxes[i] = (JCheckBox) lutCheckBox.elementAt(i*2);
          checkBoxes[i + lutColor.length] = (JCheckBox) lutCheckBox.elementAt(i*2+1);
      }
    for(int i=0; i < lutColor.length; i++)
        checkBoxes[i].addItemListener(this);
    for(int i=0; i < lutColor.length; i++)
        checkBoxes[i].addActionListener(this);
    for(int i=0; i < lutColor.length; i++)
        checkBoxes[i].setToolTipText("Checkbox Color "+(i+1));
      for(int i=0; i < lutColor.length; i++)
          checkBoxes[i+lutColor.length].setToolTipText("Selected Color "+(i+1));
    for(int i=0; i < lutColor.length; i++)
        checkBoxes[i+lutColor.length].setIcon(new ColorIcon(Color.white));
      setSelectedColor(getSelectedColor());
      gd.showDialog();
      if (gd.wasCanceled()){
          setLUT(fi);
          isShowing=false;
      }
      else if(!checkBoxes[0].isSelected()){
          setLUT(fi);
          isShowing=false;
      }
      else {isShowing=true;}
      lutDialog = false;
      return isShowing;
  }

  public String getHexColor(){
  return colorHex;
  }
  public void setHexColor(String hexcolor){
    colorHex=hexcolor;
  }
  public Color getSelectedColor(){
  return settingColor;
  }
  public Color[] getSelectedColors(){
  return lutColor;
  }
  public void setSelectedColor(Color color){
    settingColor=color;
    oldsettingColor=settingColor;
   }
  public void setSelectedLutColor(Color color){
      settingColor = color;
      oldsettingColor = settingColor;
      for(int i=0; i < lutColor.length; i++){
          if(!checkBoxes[i].isSelected())
              checkBoxes[i + lutColor.length].setIcon(new ColorIcon(color));
      }
  }
  public void resetColor(Color color){
      settingColor = color;
      oldsettingColor = settingColor;
      for(int i=0; i < lutColor.length; i++){
          checkBoxes[i].setSelected(false);
      }
      for(int i=0; i < lutColor.length; i++){
          if(!checkBoxes[i].isSelected())
              checkBoxes[i + lutColor.length].setIcon(new ColorIcon(color));
      }
        setLUT(fi);
  }

  public void setSelectedColor(JPanel panel, Color color){
      Border colorBorder = BorderFactory.createBevelBorder(bb.LOWERED, color, color);
      panel.setBorder(colorBorder);
  }
  private void jbInit() throws Exception {
    borderLayout1 = (BorderLayout) Beans.instantiate(getClass().getClassLoader(), BorderLayout.class.getName());
    colorPanel = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
    colorPane = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
    palettePanel = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
    gridBagLayout1 = (GridBagLayout) Beans.instantiate(getClass().getClassLoader(), GridBagLayout.class.getName());
    for(int i=0; i < jPanel.length; i++){
      jPanel[i] = (JPanel) Beans.instantiate(getClass().getClassLoader(),
                                             JPanel.class.getName());
    }
    tempLabel = (JLabel) Beans.instantiate(getClass().getClassLoader(), JLabel.class.getName());
    borderLayout2 = (BorderLayout) Beans.instantiate(getClass().getClassLoader(), BorderLayout.class.getName());
    borderLayout3 = (BorderLayout) Beans.instantiate(getClass().getClassLoader(), BorderLayout.class.getName());
    border1 = BorderFactory.createLineBorder(Color.black,1);
    this.setLayout(borderLayout1);
    if(colorIconArea == null){
      colorIconArea = new ColorIconArea();
    }
    createColorArea();
    palettePanel.setLayout(gridBagLayout1);
    palettePanel.setBorder(grayBorder);

    colorPanel.setLayout(borderLayout2);
    colorPane.setLayout(borderLayout3);
    colorPanel.add(palettePanel, BorderLayout.CENTER);
    colorPane.add(colorPanel, BorderLayout.CENTER);
    this.add(colorPane,  BorderLayout.CENTER);

    for(int i=2; i < jPanel.length; i++){
        palettePanel.add(jPanel[i], new GridBagConstraints(0, i - 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(0, 0, 0, 0), 0, 0));
    }
  }
  public void createColorArea(){
      final boolean isYellow = false;//basic color is yellow
    for(int i=2; i < 6; i++){
      colorIconArea.setPaletteColor(6-i, 2, isYellow);
      jPanel[i]=doGridbagLayout(colorIconArea.colorLabel0, maxColumn);
  }

      final boolean isCyan = true;// basic color is cyan
    for(int i=0; i < 5; i++){
      colorIconArea.setPaletteColor(i,0, isCyan);
      jPanel[i+6]=doGridbagLayout(colorIconArea.colorLabel0, maxColumn);
  }
      final boolean isGree = true;// basic color is gree
    for(int i=1; i < 2; i++){
      colorIconArea.setGrayPaletteColor(i, 2, isGree);
      jPanel[i+10]=doGridbagLayout(colorIconArea.colorLabel0, maxColumn);
  }
 }

public JPanel doGridbagLayout(Component[] comp, int column){
   JPanel pan = new JPanel();
   GridBagLayout   gb = new GridBagLayout() ;
   GridBagConstraints c = new GridBagConstraints();
   pan.setLayout(gb);
   c.insets = new Insets(0,0,0,0);
   c.anchor = GridBagConstraints.CENTER;
   c.weighty = 0.0; c.weightx = 0.0;
   c.gridwidth = 1;
   for(int i=0;i<comp.length;i++){
       c.gridwidth =1;
       //System.out.println("(i%column) ="+(i%column));
       if(((i%column)-column+1)==0) c.gridwidth=GridBagConstraints.REMAINDER;
       gb.setConstraints(comp[i],c);
       pan.add(comp[i],c);
   }
   return pan;
}
    public void itemStateChanged(ItemEvent e) {
        JCheckBox box = (JCheckBox)e.getItem();
        switch(index){
        case 0:break;
        case 1:
            for(int i= 0; i < lutColor.length; i++){
                if(box==checkBoxes[i] && checkBoxes[i].isSelected())
                {lutColorIndex=i;lutColor[lutColorIndex]=getSelectedColor();checkBoxes[i+lutColor.length].setIcon(new ColorIcon(lutColor[lutColorIndex]));break;}
                else if(box==checkBoxes[0] && !checkBoxes[0].isSelected()){
                    resetColor(lutColor[lutColorIndex]);break;
                }
            }
            gradientShow();
            return;
        }
    }
        public void actionPerformed(ActionEvent e) {
            Object comp = e.getSource();
            if(index == 0){
            }else if(index == 1){
                if (comp instanceof JButton) {
                    JButton temButton = (JButton)comp;
                    if (temButton.getToolTipText().equals("Color Chooser")) {
                        Color c = getSelectedColor();
                        //System.out.println("c="+c);
                        ColorChooser cc = new ColorChooser((background ?
                                "Choosed Color" :
                                "Choosed Color") + " Color", c, false);
                        c = cc.getColor();
                        setSelectedLutColor(c);
                    } else if (temButton.getToolTipText().equals("Deselect CheckBox")) {
                        resetColor(Color.black);
                        setLUT(fi);
                    }
                    else if(temButton.getToolTipText().equals("Save As Java")){
                        IJ.runPlugIn("ij2x.plugin.Lut2Java", "");
                    }
                    else if(temButton.getToolTipText().equals("Compile And Run")){
                        IJ.runPlugIn("ij.plugin.Compiler", "");
                    }
                }
                if (comp instanceof JCheckBox) {
                    JCheckBox temcheckBox = (JCheckBox)comp;
                }
            }
        }

        public void paintComponents(Graphics g){
            g.drawImage(image, 0, 0, this);

        }
        /* Lut_Apply class start
         * applies gradients to Lut
         */

        public class LutApply extends ImagePlus{

            /* function apply calculates gradients and applies it by calling showlut
             * gc[] is the color array, i the number of colours
             * Gradient is done evenly
             */

            public void apply(Color[] gc, int i) {
                if(gc == null) return;
                FileInfo fi = new FileInfo();
                fi.reds = new byte[256];
                fi.greens = new byte[256];
                fi.blues = new byte[256];
                fi.lutSize = 256;
                float nColorsfl = 256;
                float interval = nColorsfl / (float) i;
                for (int j = 0; j < i; j++) {
                    float iR = gc[j].getRed();
                    float iG = gc[j].getGreen();
                    float iB = gc[j].getBlue();
                    float idR = gc[j + 1].getRed() - gc[j].getRed();
                    float idG = gc[j + 1].getGreen() - gc[j].getGreen();
                    float idB = gc[j + 1].getBlue() - gc[j].getBlue();
                    idR = (idR / interval);
                    idG = (idG / interval);
                    idB = (idB / interval);
                    int a = 0;
                    for (a = (int) (interval * j);
                             a < (int) (interval * (j) + interval); a++,
                             iR += idR, iG += idG, iB += idB) {
                        fi.reds[a] = (byte) (iR);
                        fi.greens[a] = (byte) (iG);
                        fi.blues[a] = (byte) (iB);
                    }
                    int b = (int) (interval * j + interval) - 1;
                    fi.reds[b] = (byte) (gc[j + 1].getRed());
                    fi.greens[b] = (byte) (gc[j + 1].getGreen());
                    fi.blues[b] = (byte) (gc[j + 1].getBlue());
                    nColorsfl = 256;
                }
                if (nColorsfl > 0) {
                    if (nColorsfl < 256)
                        interpolate(fi.reds, fi.greens, fi.blues,
                                    (int) nColorsfl);
                    //fi.fileName = arg;
                    showLut(fi, true);
                    return;
                }
            }


            /* applies the new Lut on the actual image*/
            void showLut(FileInfo fi, boolean showImage) {
                ImagePlus imp = WindowManager.getCurrentImage();
                if (imp != null) {
                    if (imp.getType() == ImagePlus.COLOR_RGB)
                        IJ.error(
                                "Color tables cannot be assiged to RGB Images.");
                    else {
                        ImageProcessor ip = imp.getProcessor();
                        ColorModel cm = null;
                        if(!checkBoxes[0].isSelected()) cm = ip.getColorModel();
                        else cm = new IndexColorModel(8, 256, fi.reds, fi.greens, fi.blues);
                        ip.setColorModel((ColorModel)cm);
                        if (imp.getStackSize() > 1)
                            imp.getStack().setColorModel((ColorModel)cm);
                        plot.setHistogram(imp);
                        plot.repaint();
                        imp.updateAndDraw();
                   }
                }else {createImageAndShow(fi, showImage);
               }
            }

            /* function interpolate taken out from the orignal ImageJ project from Wayne Rasband
             * Couldn't find a way to have straight access to this method so I had
             * to add it manually.
             */

            void interpolate(byte[] reds, byte[] greens, byte[] blues,
                             int nColors) {
                byte[] r = new byte[nColors];
                byte[] g = new byte[nColors];
                byte[] b = new byte[nColors];
                System.arraycopy(reds, 0, r, 0, nColors);
                System.arraycopy(greens, 0, g, 0, nColors);
                System.arraycopy(blues, 0, b, 0, nColors);
                double scale = nColors / 256.0;
                int i1, i2;
                double fraction;
                for (int i = 0; i < 256; i++) {
                    i1 = (int) (i * scale);
                    i2 = i1 + 1;
                    if (i2 == nColors)
                        i2 = nColors - 1;
                    fraction = i * scale - i1;
                    reds[i] = (byte) ((1.0 - fraction) * (r[i1] & 255) +
                                      fraction * (r[i2] & 255));
                    greens[i] = (byte) ((1.0 - fraction) * (g[i1] & 255) +
                                        fraction * (g[i2] & 255));
                    blues[i] = (byte) ((1.0 - fraction) * (b[i1] & 255) +
                                       fraction * (b[i2] & 255));
                }
            }
            ImageProcessor createImage(FileInfo fi) {
                    int width = 256;
                    int height = 32;
                    IndexColorModel cm = new IndexColorModel(8, 256, fi.reds, fi.greens, fi.blues);
                    byte[] pixels = new byte[width*height];
                    ByteProcessor bp = new ByteProcessor(width, height, pixels, cm);
                    int[] ramp = new int[width];
                    for (int i=0; i<width; i++)
                            ramp[i] = i;
                    for (int y=0; y<height; y++)
                            bp.putRow(0, y, ramp, width);
            setProcessor(fi.fileName, bp);
            return bp;
            }

            void createImageAndShow(FileInfo fi, boolean show) {
                  createImage(fi);
                        if (show)
                    show();
            }
        }
        /* Lut_Apply class end*/
        private void gradientShow(){
                    LutApply LA = new LutApply();
                      try {
                          if(lutColorIndex == 0){lutColorIndex++;lutColor[1]=lutColor[0];} LA.apply(lutColor,lutColorIndex);
                      } catch (Exception ex) {
                          IJ.beep();
                      }
    }

    /* kind of a push and pop LUT functions, used for the Preview of the gradient
    */

    public FileInfo getLUT(){
        FileInfo f =  WindowManager.getCurrentImage().getFileInfo();
        return f;
    }

    public void setLUT(FileInfo fi){
       LutApply LAP = new LutApply();
       LAP.showLut(fi,true);
    }

    private ImagePlus generateSampleImage( int width,  int height) {

            /* imagewidth: width = 256;
            *imageheight: height = 32;
            *imagepixels: pixels = new int [width*height];
            * **/
            int[] pixels = new int [width*height];
            MemoryImageSource source = new MemoryImageSource(width, height, pixels, 0, width);

            Image awtImage = Toolkit.getDefaultToolkit().createImage(source);

            BufferedImage bufferedImage =  new BufferedImage(width, height, BufferedImage.TYPE_BYTE_GRAY);
            Graphics2D g2D = bufferedImage.createGraphics();

            g2D.drawImage(awtImage, 0, 0, null);
            g2D.dispose();
            ImagePlus imp = new ImagePlus("LUT Image", bufferedImage);
            //ImageCanvas canvas = new ImageCanvas(imp);
            return  imp;
    }


// build color icon area as color palette
  //public class ColorIconArea extends JComponent implements java.awt.event.MouseListener{

  public class ColorIconArea{


      int column = 6;
      int[] row = new int[column];
    int[] intColor = {0, 0, 0};
    JLabel[] colorLabel0 = new JLabel[(row.length-1)*column];

    Color[] color = new Color[column];
    Icon[] icon = new Icon[column];

    //default constructor
    public ColorIconArea(){
        for(int i=0; i < column; i++)
            row[i]=(column-1)*(i+1);
        for (int i = 0; i < colorLabel0.length; i++) {
            //colorLabel0[i]=new JLabel();
        }
    }

    public void setPaletteColor(int k, int block, boolean isCyan) {
      Color cyanColor=Color.CYAN;
      for (int i = 0; i < maxColumn; i++) {
        if (i < row[0]) {
          if (i == 0){
              cyanColor = isCyan ? new Color(0, 51 * k, 51 * k): new Color(51 * k, 0, 51 * k);
          setRGB(block, new Color(0, 51, 0), new Color(0, 255, 255), cyanColor);
        }
          setLabel(i, 0);
        }
        else if (i >= row[0] && i < row[1]) {
          if (i == row[0]){
              cyanColor = isCyan ? new Color(51 * k, 0, 51 * k): new Color(0, 51 * k, 51 * k);
          setRGB(block+1, new Color(51, 0, 0), new Color(255, 0, 255), cyanColor);
        }
          setLabel(i, row[0]);
        }
        else if (i >= row[1] && i < row[2]) {
          if (i == row[1]){
              cyanColor = isCyan ? new Color(51 * k, 0, 51 * k): new Color(51 * k, 51 * k, 0);
              setRGB(block, new Color(0, 0, 51), new Color(255, 0, 255), cyanColor);
        }
          setLabel(i, row[1]);
        }
        else if (i >= row[2] && i < row[3]) {
          if (i == row[2]){
              cyanColor = isCyan ? new Color(51 * k, 51 * k, 0): new Color(51 * k, 0, 51 * k);
          setRGB(block+1, new Color(0, 51, 0), new Color(255, 255, 0), cyanColor);
        }
          setLabel(i, row[2]);
        }
        else if (i >= row[3] && i < row[4]) {
          if (i == row[3]){
              cyanColor = isCyan ? new Color(51 * k, 51 * k, 0): new Color(0, 51 * k, 51 * k);
          setRGB(block, new Color(51, 0, 0), new Color(255, 255, 0), cyanColor);
        }
          setLabel(i, row[3]);
        }
        else if (i >= row[4] && i < row[5]) {
          if (i == row[4]){
              cyanColor = isCyan ? new Color(0, 51 * k, 51 * k): new Color(51 * k, 51 * k, 0);
         setRGB(block+1, new Color(0, 0, 51), new Color(0, 255, 255), cyanColor);
        }
          setLabel(i, row[4]);
        }

        colorLabel0[i].addMouseMotionListener(new java.awt.event.
                                              MouseMotionListener() {
          public void mouseMoved(MouseEvent e) {
            //if(pressed)
            colorLabel_mouseMoved(e);
          }

          public void mouseDragged(MouseEvent e) {}
        });
        colorLabel0[i].setBorder(BorderFactory.createLineBorder(Color.lightGray,
            1));
      }
    }
    public void setGrayPaletteColor(int k, int block, boolean isCyan) {
      Color cyanColor=Color.CYAN;
      for (int i = 0; i < maxColumn; i++) {
        if (i < row[0]) {
          if (i == 0){
              cyanColor = isCyan ? new Color(51 * 0, 51 * 0, 51 * 0): new Color(51 * k, 0, 51 * k);
          setRGB(block, new Color(0, 0, 0), new Color(0, 0, 0), cyanColor);
        }
          setLabel(i, 0);
        }
        else if (i >= row[0] && i < row[1]) {
          if (i == row[0]){
              cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(0, 51 * k, 51 * k);
          setRGB(block+1, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
        }
          setLabel(i, row[0]);
        }
        else if (i >= row[1] && i < row[2]) {
          if (i == row[1]){
              cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(51 * k, 51 * k, 0);
              setRGB(block, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
        }
          setLabel(i, row[1]);
        }
        else if (i >= row[2] && i < row[3]) {
          if (i == row[2]){
              cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(51 * k, 0, 51 * k);
          setRGB(block+1, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
        }
          setLabel(i, row[2]);
        }
        else if (i >= row[3] && i < row[4]) {
          if (i == row[3]){
              cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(0, 51 * k, 51 * k);
          setRGB(block, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
        }
          setLabel(i, row[3]);
        }
        else if (i >= row[4] && i < row[5]) {
          if (i == row[4]){
              cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(51 * k, 51 * k, 0);
         setRGB(block+1, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
        }
          setLabel(i, row[4]);
        }

        colorLabel0[i].addMouseMotionListener(new java.awt.event.
                                              MouseMotionListener() {
          public void mouseMoved(MouseEvent e) {
            //if(pressed)
            colorLabel_mouseMoved(e);
          }

          public void mouseDragged(MouseEvent e) {}
        });
        colorLabel0[i].setBorder(BorderFactory.createLineBorder(Color.lightGray,
            1));
      }
    }
   void setLabel(int i, int col){
       if((i-col) < 0)i=col;
       icon[i - col] = new ColorIcon(color[i - col]);
       colorLabel0[i] = new JLabel(icon[i - col]);
       createIconToolTipText(colorLabel0[i], color[i - col]);
   }


    public void setRGB(int choose, Color rgb, Color rgbMax, Color rgbMin){

        int r=rgb.getRed();
        int g=rgb.getGreen();
        int b=rgb.getBlue();
        int maxr=rgbMax.getRed();
        int maxg=rgbMax.getGreen();
        int maxb=rgbMax.getBlue();
        int minr=rgbMin.getRed();
        int ming=rgbMin.getGreen();
        int minb=rgbMin.getBlue();
        int remeindr =0;
        int remeindg =0;
        int remeindb =0;
        int k = 0;
        int length= 0;
        if(minr >= 51)
        remeindr=minr/51;
        if(ming >= 51)
        remeindg=ming/51;
        if(minb >= 51)
        remeindb=minb/51;
        k=remeindr|remeindg|remeindb;
        //System.out.println("inc_k="+k);
        length = color.length-k;
      switch(choose){
      case 0:{
          for(int i = 0; i < length; i++){
              for(int j = 0; j < 3; j++){
              if(j==0)
              intColor[j]=(maxr-minr)-i*r;
              if(j==1)
              intColor[j]=(maxg-ming)-i*g;
              if(j==2)
              intColor[j]=(maxb-minb)-i*b;
              }
          color[i+k] = new Color(intColor[0], intColor[1], intColor[2]);
              }
              if(k ==1)color[0]=color[1];
              else if(k ==2){
                for(int i=0; i < k; i++)
                  color[i]=color[k];
                 }
              else if(k ==3){
                for(int i=0; i < k; i++)
                 color[i]=color[k];
              }
              else if(k ==4){
                for(int i=0; i < k; i++)
                     color[i]=color[k];
              }
              else if(k ==5){
                for(int i=0; i < k; i++)
                     color[i]=color[k];
              }
              break;
      }
      case 1:{
          for(int i = 0; i < length; i++){
              for(int j = 0; j < 3; j++){
              if(j==0)
              intColor[j]=(maxr-minr)-(length-i-1)*r;
              if(j==1)
              intColor[j]=(maxg-ming)-(length-i-1)*g;
              if(j==2)
              intColor[j]=(maxb-minb)-(length-i-1)*b;
              }
          color[i+k] = new Color(intColor[0], intColor[1], intColor[2]);
              }
              if(k ==1)color[0]=color[1];
              else if(k ==2){
                for(int i=0; i < k; i++)
                  color[i]=color[k];
                 }
              else if(k ==3){
                for(int i=0; i < k; i++)
                 color[i]=color[k];
              }
              else if(k ==4){
                for(int i=0; i < k; i++)
                     color[i]=color[k];
              }
              else if(k ==5){
                for(int i=0; i < k; i++)
                     color[i]=color[k];
              }
              break;
      }
      case 2:{
          for(int i = 0; i < length; i++){
              for(int j = 0; j < 3; j++){
              if(j==0)
                if(r==0 && maxr == 0)intColor[j]=minr;
              else
              intColor[j]=(maxr-0)-i*r;
              if(j==1)
                if(g==0 && maxg == 0)intColor[j]=ming;
              else
              intColor[j]=(maxg-0)-i*g;
              if(j==2)
                if(b==0 && maxb == 0)intColor[j]=minb;
              else
              intColor[j]=(maxb-0)-i*b;
              }
          color[i] = new Color(intColor[0], intColor[1], intColor[2]);
              }
              if(k ==1)color[5]=color[4];
              else if(k ==2){
                for(int i=0; i < k; i++)
                  color[5-i]=color[5-k];
                 }
              else if(k ==3){
                for(int i=0; i < k; i++)
                 color[5-i]=color[5-k];
              }
              else if(k ==4){
                for(int i=0; i < k; i++)
                     color[5-i]=color[5-k];
              }
              else if(k ==5){
                for(int i=0; i < k; i++)
                     color[5-i]=color[5-k];
              }
              break;
      }
      case 3:{
          for(int i = 0; i < length; i++){
              for(int j = 0; j < 3; j++){
              if(j==0)
                if(r==0 && maxr == 0)intColor[j]=minr;
              else
              intColor[j]=(maxr-0)-(length-i-1)*r;
              if(j==1)
                if(g==0 && maxg == 0)intColor[j]=ming;
              else
              intColor[j]=(maxg-0)-(length-i-1)*g;
              if(j==2)
                if(b==0 && maxb == 0)intColor[j]=minb;
              else
              intColor[j]=(maxb-0)-(length-i-1)*b;
              }
          color[i] = new Color(intColor[0], intColor[1], intColor[2]);
              }
              if(k ==1)color[5]=color[4];
              else if(k ==2){
                for(int i=0; i < k; i++)
                  color[5-i]=color[5-k];
                 }
              else if(k ==3){
                for(int i=0; i < k; i++)
                 color[5-i]=color[5-k];
              }
              else if(k ==4){
                for(int i=0; i < k; i++)
                     color[5-i]=color[5-k];
              }
              else if(k ==5){
                for(int i=0; i < k; i++)
                     color[5-i]=color[5-k];
              }
              break;
      }
      }

    }

    public void colorLabel_mouseMoved(MouseEvent e){
      tempLabel.setBorder(BorderFactory.createLineBorder(Color.lightGray, 1));
      JLabel colorLabel = (JLabel)e.getSource();
      tempLabel = colorLabel;
      //tempLabel.addMouseListener(this);
      colorLabel.setBorder(BorderFactory.createLineBorder(Color.white, 1));

      settingColor = ((ColorIcon)colorLabel.getIcon()).getColor();
      StringBuffer hexValue = new StringBuffer();
      hexValue.append(Integer.toHexString(settingColor.getRGB()));
      colorHex = "0x"+hexValue.toString().toUpperCase();

      if(index == 0){
          setSelectedColor(settingColor);
      }
      else if(index == 1){
          setSelectedLutColor(settingColor);
      }
    }

    public void colorLabel_mousePressed(MouseEvent e){

      if (!SwingUtilities.isRightMouseButton(e)){
          setSelectedColor(settingColor);
      }

      //tempLabel.removeMouseListener(this);
      repaint();
    }
    // create color icon ToolTipText
    public JLabel createIconToolTipText(JLabel label, Color color){
      final JLabel colorLabel = label;
      colorLabel.setToolTipText(Integer.toString(color.getRed())
                            +", "+Integer.toString(color.getGreen())
                               +", "+Integer.toString(color.getBlue()));
      return colorLabel;
    }


  }

}
class GradientPlot extends JComponent implements Measurements {

        static final int WIDTH = 256, HEIGHT=68;
        double minThreshold = 85;
        double maxThreshold = 170;
        int[] histogram;
        Color[] hColors;
        int hmax;
        Image os;
        Graphics osg;
        int mode;

        public GradientPlot() {
                //addMouseListener(this);
                setSize(WIDTH+1, HEIGHT+1);
        }

    /** Overrides Component getPreferredSize(). Added to work
        around a bug in Java 1.4.1 on Mac OS X.*/
    public Dimension getPreferredSize() {
        return new Dimension(WIDTH+1, HEIGHT+1);
    }

        ImageStatistics setHistogram(ImagePlus imp) {
                ImageProcessor ip = imp.getProcessor();
                if (!(ip instanceof ByteProcessor)) {
                        double min = ip.getMin();
                        double max = ip.getMax();
                        ip.setMinAndMax(min, max);
                        ip = new ByteProcessor(ip.createImage());
                }
                ip.setRoi(imp.getRoi());
                ImageStatistics stats = ImageStatistics.getStatistics(ip, AREA+MIN_MAX+MODE, null);
                int maxCount2 = 0;
                histogram = stats.histogram;
                for (int i = 0; i < stats.nBins; i++)
                        if ((histogram[i] > maxCount2) && (i != stats.mode))
                                maxCount2 = histogram[i];
                hmax = stats.maxCount;
                if ((hmax>(maxCount2 * 2)) && (maxCount2 != 0)) {
                        hmax = (int)(maxCount2 * 1.5);
                        histogram[stats.mode] = hmax;
                }
                os = null;

                ColorModel cm = ip.getColorModel();
                if (!(cm instanceof IndexColorModel))
                        return null;
                IndexColorModel icm = (IndexColorModel)cm;
                int mapSize = icm.getMapSize();
                if (mapSize!=256)
                        return null;
                byte[] r = new byte[256];
                byte[] g = new byte[256];
                byte[] b = new byte[256];
                icm.getReds(r);
                icm.getGreens(g);
                icm.getBlues(b);
                hColors = new Color[256];
                for (int i=0; i<256; i++)
                        hColors[i] = new Color(r[i]&255, g[i]&255, b[i]&255);
                return stats;
        }

        public void update(Graphics g) {
            paintComponent(g);
        }

        public void paintComponent(Graphics g) {
            super.paintComponent(g);
                if (g==null) return;
                if (histogram!=null) {
                        if (os==null && hmax>0) {
                                os = createImage(WIDTH,HEIGHT);
                                osg = os.getGraphics();
                                UIDefaults uid = UIManager.getLookAndFeel().getDefaults();
                                Color bg = uid.getColor("Panel.background");
                                osg.setColor(Color.white);
                                osg.fillRect(0, 0, WIDTH, HEIGHT-20);
                                osg.setColor(bg);
                                osg.fillRect(0, HEIGHT-20, WIDTH, 20);
                                osg.setColor(Color.gray);
                                for (int i = 0; i < WIDTH; i++) {
                                        if (hColors!=null) osg.setColor(hColors[i]);
                                        osg.drawLine(i, HEIGHT-20, i, HEIGHT-20 - ((int)((HEIGHT-20) * histogram[i])/hmax));
                                        osg.drawLine(i, HEIGHT-12, i, HEIGHT-5);
                                }
                                osg.dispose();
                        }
                        g.drawImage(os, 0, 0, this);
                } else {
                        g.setColor(Color.white);
                        g.fillRect(0, 0, WIDTH, HEIGHT);
                }
                g.setColor(Color.black);
                g.drawRect(0, 0, WIDTH, HEIGHT);
    }


} // ThresholdPlot class
