package ij2x.plugin.frame;

import com.bric.swing.ColorPicker;

import java.awt.*;

import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.event.*;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import org.jdesktop.swingx.JXCollapsiblePane;
import org.jdesktop.swingx.JXCollapsiblePane.Direction;
import ij2x.plugin.frame.ColorPickerConstance;
import ij.plugin.frame.PlugInFrame;
import ij.gui.GUI;
import ij.Prefs;
import ij.WindowManager;
import java.beans.Beans;
import ij.IJ;
import ij.IJEventListener;
import ij2x.plugin.ThreeColor;
import ij.gui.Toolbar;
import ij.ImagePlus;
import ij.gui.Roi;

/** This is a panel that offers a robust set of controls to pick a color.
 */
public class ColorPane  extends PlugInFrame implements ColorPickerConstance{
        private static final long serialVersionUID = 4L;
        public JTabbedPane colorChooice;
        private JPanel colorSelection;
        private ColorPicker pickerSAT, pickerHUE, pickerBRI, pickerRED, pickerGREEN, pickerBLUE;
        public ColorPicker picker;
        private JCheckBox roiColor, fgColor, bgColor;
        public static ColorPane instance;
        private static final String LOC_KEY = "jcp.loc";
        private SingleSelectionModel model;
        private GridBagLayout colorPaneLayout, colorSelectionLayout;
        private Color settingColor, oldsettingColor;
        public static int tempColor=0;
        ColorSwatchs colorSwatchs;
        Dimension dim;
        public static boolean isRoiChecked=ThreeColor.isRoiChecked
                                   , isFGChecked=ThreeColor.isFGChecked
                                        , isBGChecked=ThreeColor.isBGChecked;
        public Border grayBorder = BorderFactory.createBevelBorder(BevelBorder.LOWERED, Color.gray, Color.lightGray);

    public ColorPane() {
        super("JColorPane");
        if (instance!=null) {
                WindowManager.toFront(instance);
                return;
        }
        instance = this;
        try {
            jbInit();
            setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
            super.setUndecorated(false);
            pack();
            Point loc = Prefs.getLocation(LOC_KEY);
            if (loc!=null)
                    setLocation(loc);
            else
                    GUI.center(this);
            setVisible(true);
            //palette.setVisible(true);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        if(IJ.isMacintosh()){
            dim = new Dimension(400, 335); //MAC Size
            }else if(IJ.isSolaris()){
                dim = new Dimension(350, 254); // OS SUN Size           	
            }
            else if(IJ.isLinux()){
                dim = new Dimension(350, 250); // Linux Size           	
            }
            else if(IJ.isWindows()){
                dim = new Dimension(350, 256); // Windows Size
            }else{
                dim = new Dimension(350, 250); // Metal Size          	
            }
        colorChooice = (JTabbedPane) Beans.instantiate(getClass().getClassLoader(), JTabbedPane.class.getName());
        colorPaneLayout = (GridBagLayout) Beans.instantiate(getClass().getClassLoader(), GridBagLayout.class.getName());
        colorSelectionLayout = (GridBagLayout) Beans.instantiate(getClass().getClassLoader(), GridBagLayout.class.getName());
        roiColor = (JCheckBox) Beans.instantiate(getClass().getClassLoader(), JCheckBox.class.getName());
        fgColor = (JCheckBox) Beans.instantiate(getClass().getClassLoader(), JCheckBox.class.getName());
        bgColor = (JCheckBox) Beans.instantiate(getClass().getClassLoader(), JCheckBox.class.getName());
        colorSelection = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
        pickerHUE = new ColorPicker(true,true);
        //pickerHUE.setOpacityVisible(true);
        pickerHUE.setModeControlsVisible(false);
        pickerHUE.setPreferredSize(dim);

        pickerBRI = new ColorPicker(true,true);
        //pickerBRI.setOpacityVisible(true);
        pickerBRI.setModeControlsVisible(false);
        pickerBRI.setPreferredSize(dim);

        pickerSAT = new ColorPicker(true,true);
        //pickerSAT.setOpacityVisible(true);
        pickerSAT.setModeControlsVisible(false);
        pickerSAT.setPreferredSize(dim);

        pickerRED = new ColorPicker(true,true);
        //pickerRED.setOpacityVisible(true);
        pickerRED.setModeControlsVisible(false);
        pickerRED.setPreferredSize(dim);

        pickerGREEN = new ColorPicker(true,true);
        //pickerGREEN.setOpacityVisible(true);
        pickerGREEN.setModeControlsVisible(false);
        pickerGREEN.setPreferredSize(dim);

        pickerBLUE = new ColorPicker(true,true);
        //pickerBLUE.setOpacityVisible(true);
        pickerBLUE.setModeControlsVisible(false);
        pickerBLUE.setPreferredSize(dim);

        colorChooice.add(pickerHUE, "Hue");
        colorChooice.add(pickerBRI, "Bri");
        colorChooice.add(pickerSAT, "Sat");

        colorChooice.add(pickerRED, "Red");
        colorChooice.add(pickerGREEN, "Green");
        colorChooice.add(pickerBLUE, "Blue");
        colorSwatchs = new ColorSwatchs();
        colorChooice.add(colorSwatchs, "Swatches");

        colorChooice.getModel().setSelectedIndex(ColorPicker.SWATCH);
        picker=pickerBRI;
        colorSelection.setPreferredSize(new Dimension(dim.width, colorSelection.getPreferredSize().height+20));
        colorSelection.setBorder(grayBorder);

        if(!isRoiChecked&&!isFGChecked&&!isBGChecked){picker.setColor(Roi.getColor());roiColor.setSelected(true);}

        if(ThreeColor.isRoiChecked){
            picker.setColor(Roi.getColor());
            roiColor.setSelected(ThreeColor.isRoiChecked);
            tempColor=0;
        }
        else if(ThreeColor.isFGChecked){
            picker.setColor(Toolbar.getForegroundColor());
            fgColor.setSelected(ThreeColor.isFGChecked);
            tempColor=1;
        }
        else if(ThreeColor.isBGChecked){
            picker.setColor(Toolbar.getBackgroundColor());
            bgColor.setSelected(ThreeColor.isBGChecked);
            tempColor=2;
        }
        MouseInputListener mouseListener = new MouseInputAdapter() {
                public void mouseMoved(MouseEvent e) {
                        setSelectedColor(picker.getColor());

                }

                public void mouseDragged(MouseEvent e) {
                        mouseMoved(e);
                }
        };
        colorChooice.getModel().addChangeListener(
            new ChangeListener(){
                public void stateChanged(ChangeEvent e){
                    stateChangedModel(e);
                }
            });
        ItemListener itemListener = new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                Object obj = e.getSource();
                JCheckBox src = (JCheckBox)obj;
            if(src.isSelected() && src==roiColor) {
                    tempColor=0;
                    picker.setColor(Roi.getColor());
            }else if(src.isSelected() && src==fgColor) {
                    tempColor=1;
                    picker.setColor(Toolbar.getForegroundColor());
            }else if(src.isSelected() && src==bgColor) {
                    tempColor=2;
                    picker.setColor(Toolbar.getBackgroundColor());
            }
                setSelectedColor(picker.getColor());
            }
        };
        ActionListener cbActionListener = new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                        Object src = e.getSource();
                        if(src==roiColor) {
                                tempColor=0;
                                isRoiChecked=true;
                                isFGChecked=false;
                                isBGChecked=false;
                                roiColor.setSelected(true);
                                fgColor.setSelected(false);
                                bgColor.setSelected(false);
                        }else if(src==fgColor) {
                                tempColor=1;
                                isRoiChecked=false;
                                isFGChecked=true;
                                isBGChecked=false;
                                fgColor.setSelected(true);
                                roiColor.setSelected(false);
                                bgColor.setSelected(false);
                        }else if(src==bgColor) {
                                isRoiChecked=false;
                                isFGChecked=false;
                                isBGChecked=true;
                                fgColor.setSelected(false);
                                roiColor.setSelected(false);
                                bgColor.setSelected(true);
                                tempColor=2;
                        }
                 }
        };
        ChangeListener changeListener = new ChangeListener() {
            public void stateChanged(ChangeEvent evt) {
                setSelectedColor(picker.getColor());
            }
        };
        picker.opacitySlider.addChangeListener(changeListener);
        pickerHUE.colorPanel.addMouseMotionListener(mouseListener);
        pickerBRI.colorPanel.addMouseMotionListener(mouseListener);
        pickerSAT.colorPanel.addMouseMotionListener(mouseListener);
        pickerRED.colorPanel.addMouseMotionListener(mouseListener);
        pickerGREEN.colorPanel.addMouseMotionListener(mouseListener);
        pickerBLUE.colorPanel.addMouseMotionListener(mouseListener);
        roiColor.addItemListener(itemListener);
        fgColor.addItemListener(itemListener);
        bgColor.addItemListener(itemListener);
        roiColor.addActionListener(cbActionListener);
        fgColor.addActionListener(cbActionListener);
        bgColor.addActionListener(cbActionListener);

        container.setLayout(colorPaneLayout);
        colorSelection.setLayout(colorSelectionLayout);
        roiColor.setText("ROI Color");
        fgColor.setText("Foreground");
        bgColor.setText("Background");
        colorSelection.add(roiColor, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        colorSelection.add(fgColor, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        colorSelection.add(bgColor, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        this.add(colorChooice, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.9
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        this.add(colorSelection, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.1
                ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));/**/
        //colorChooice.add(null, "Exit");
    }

    public void stateChangedModel(ChangeEvent e){
        model = (SingleSelectionModel)e.getSource();
        int i = model.getSelectedIndex();
        if(i==HUE) {
                pickerHUE.setMode(ColorPicker.HUE);
                pickerHUE.setColor(picker.getColor());
                picker = pickerHUE;
        } else if(i==SAT) {
                pickerSAT.setMode(ColorPicker.SAT);
                pickerSAT.setColor(picker.getColor());
                picker = pickerSAT;
        } else if(i==BRI) {
                pickerBRI.setMode(ColorPicker.BRI);
                pickerBRI.setColor(picker.getColor());
                picker = pickerBRI;
        } else if(i==RED) {
                pickerRED.setMode(ColorPicker.RED);
                pickerRED.setColor(picker.getColor());
                picker = pickerRED;
        } else if(i==GREEN) {
                pickerGREEN.setMode(ColorPicker.GREEN);
                pickerGREEN.setColor(picker.getColor());
                picker = pickerGREEN;
        } else if(i==BLUE) {
                pickerBLUE.setMode(ColorPicker.BLUE);
                pickerBLUE.setColor(picker.getColor());
                picker = pickerBLUE;
        } else if(i==EXIT) {
                //close();
        }
        //setSelectedColor(picker.getColor());
        //System.out.println(""+model.getSelectedIndex());
    }

    /** Closes this window. */
  public void close() {
      super.close();
      instance = null;
      ThreeColor.isRoiChecked=isRoiChecked;
       ThreeColor.isFGChecked=isFGChecked;
         ThreeColor.isBGChecked=isBGChecked;
      Prefs.saveLocation(LOC_KEY, getLocation());
      IJ.notifyEventListeners(IJEventListener.COLOR_PICKER_CLOSED);
  }

 public void windowClosing(WindowEvent e) {
     close();
 }
 public void setSelectedColor(Color color){
     settingColor=color;
     oldsettingColor=settingColor;
     ij.plugin.frame.ColorPicker picker = ij.plugin.frame.ColorPicker.instance;
     Toolbar toolbar = Toolbar.getInstance();
     if(tempColor == 0){
      Roi.setColor(color);
      ImagePlus imp = WindowManager.getCurrentImage();
      if (imp!=null && imp.getRoi()!=null) imp.draw();
  }
     else if(tempColor == 1){
      Toolbar.setForegroundColor(color);
      if(picker instanceof ij.plugin.frame.ColorPicker)
      picker.refresh();
      toolbar.repaint();
 }
     else if(tempColor == 2){
      Toolbar.setBackgroundColor(color);
      if(picker instanceof ij.plugin.frame.ColorPicker)
      picker.refresh();
      toolbar.repaint();
 }
     colorSwatchs.cpDemo.setColor(color);
     colorSwatchs.cpDemo.repaint();

}

}
