package ij2x.plugin.frame;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2011</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public interface ColorPickerConstance {
    /** <code>PropertyChangeEvents</code> will be triggered for this property when the selected color
     * changes.
     * <P>(Events are only created when then RGB values of the color change.  This means, for example,
     * that the change from HSB(0,0,0) to HSB(.4,0,0) will <i>not</i> generate events, because when the
     * brightness stays zero the RGB color remains (0,0,0).  So although the hue moved around, the color
     * is still black, so no events are created.)
     *
     */
    public static final String SELECTED_COLOR_PROPERTY = "selected color";

    /** <code>PropertyChangeEvents</code> will be triggered for this property when <code>setModeControlsVisible()</code>
     * is called.
     */
    public static final String MODE_CONTROLS_VISIBLE_PROPERTY = "mode controls visible";

    /** <code>PropertyChangeEvents</code> will be triggered when the opacity value is
     * adjusted.
     */
    public static final String OPACITY_PROPERTY = "opacity";

    /** <code>PropertyChangeEvents</code> will be triggered when the mode changes.
     * (That is, when the wheel switches from HUE, SAT, BRI, RED, GREEN, or BLUE modes.)
     */
    public static final String MODE_PROPERTY = "mode";

    /** Used to indicate when we're in "hue mode". */
    public static final int HUE = 0;
    /** Used to indicate when we're in "brightness mode". */
    public static final int BRI = 1;
    /** Used to indicate when we're in "saturation mode". */
    public static final int SAT = 2;
    /** Used to indicate when we're in "red mode". */
    public static final int RED = 3;
    /** Used to indicate when we're in "green mode". */
    public static final int GREEN = 4;
    /** Used to indicate when we're in "blue mode". */
    public static final int BLUE = 5;
    /** Used to indicate when we're in "swatche mode". */
    public static final int SWATCH = 6;

    public static final int EXIT = 7;

}
